#!/usr/bin/perl -w
# WAB - the Wolfenstein Admin Bot
# An administration assistant for Return to Castle Wolfenstein Multiplayer
# server admins.  See http://www.castlewolfenstein.com/ for more infor
# on this excellent game.
#
# Copyright (C) 2001 Brett A. Thomas <quark@baz.com>.  All rights reserved.
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.
# 
# Email quark@baz.com with questions, comments and patches, and
# especially see the WAB homepage at http://www.baz.com/quark/software/wab/

package Wab;

use strict;
use Carp;
use Symbol;
use POSIX;
use IO::Socket;
use IO::Select;
use Text::ParseWords;

my $VERSION = "1.0";


my %SayCommand = ("kick" => {"needs_admin" => 1,
			     "func" => \&SayCommandKick},
		  "kiclient" => {"needs_admin" => 1,
				 "func" => \&SayCommandKickClient});

my %Files = ("CHANGES" => {"name" => "CHANGES",
			   "overwrite" => 1,
			   "dos_extension" => ".TXT"},
	     "README" => {"name" => "README",
			  "overwrite" => 1,
			  "dos_extension" => ".TXT"},
	     "INSTALL" => {"name" => "INSTALL",
			   "overwrite" => 1,
			   "dos_extension" => ".TXT"},
	     "INSTALL_WIN32.TXT" => {"name" => "INSTALL_WIN32",
				 "overwrite" => 1,
				 "dos_extension" => undef},
	     "CREDITS" => {"name" => "CREDITS",
			   "overwrite" => 1,
			   "dos_extension" => ".TXT"},
	     "TODO" => {"name" => "TODO",
			"overwrite" => 1,
			"dos_extension" => ".TXT"},
	     "UPGRADING" => {"name" => "UPGRADING",
			     "overwrite" => 1,
			     "dos_extension" => ".TXT"},
	     "wab" => {"name" => "wab",
		       "overwrite" => 1,
		       "dos_extension" => ".pl"},
	     "Wab.pm" => {"name" => "Wab.pm",
			  "overwrite" => 1,
			  "dos_extension" => undef},
	     "killwab" => {"name" => "killwab",
			   "overwrite" => 1,
			   "dos_extension" => ".pl"},
	     "install-wab" => {"name" => "install-wab",
			       "overwrite" => 1,
			       "dos_extension" => ".pl"},
	     "setup.bat" => {"name" => "setup.bat",
					 "overwrite" => 1,
					 "dos_extension" => undef},
	     "wab.cfg" => {"name" => "wab.cfg",
			   "overwrite" => 0,
			   "dos_extension" => undef}
	 );
	     		      
my %ConfigFields = ("server" => {"#category_required" => 1,
				 "ip" => "optional:127.0.0.1",
				 "oob_port" => "optional:27960",
				 "rcon" => "required",
				 "illegal_names" => "optional:dick,penis,fuck,shit,damn,nigger,hitler,himmler,himler,vagina,adolph,adolf,bitch,ass,boobies,cock,tker,tk_er,balls,tampon,TK,boner,poop,piss,parts,privates,mike hunt,pol pot,urinal",
				 "enforce_names" => "optional:1",
				 "min_score" => "optional:-6",
				 "enforce_score" => "optional:1",
				 "kick_users" => "optional:1",
				 "motd_frequency" => "optional:300",
				 "motd" => "optional:Wolfenstein Admin Bot - www.tqchallenge.org/wab",
				 "poll_status_frequency" => "optional:10",
				 "logfile" => "optional:/usr/local/games/wolfenstein/wab.log",
				 "game_logfile" => "optional:/usr/local/games/wolfenstein/demomain/games.log",
				 "debug_logfile" => "optional:wab_debug.log",
				 "round_length" => "optional:default",
				 "timeout" => "optional:.2",
				 "retry" => "optional:5",
				 "restart_sleep" => "optional:20",
				 "kill_server" => "optional:0",
				 "disconnect_ban" => "optional:0",
				 "kick_name_spammers" => "optional:0",
				 "max_name_changes_per_second" => "optional:1",
				 "reconnect_on_failure" => "optional:1",
				 "reconnect_sleep" => "optional:30",
				 "kick_grenade_cheaters" => "optional:1",
				 "grenade_cheat_ban_time" => "optional:1800",
				 "soldier_grenades" => "optional:4",
				 "engineer_grenades" => "optional:8",
				 "medic_grenades" => "optional:1",
				 "lt_grenades" => "optional:1",
				 "kick_names_with_leading_spaces" => "optional:1"
#				 "kick_voice_spammers" => "optional:1",
#				 "max_voices_per_ten_seconds" => "optional:5",
				 },
		    "user" => {"#category_required" => 0,
			       "name" => "required",
			       "ips" => "optional:",
			       "protect_nick" => "optional:0",
			       "ignore_offenses" => "optional:0",
			       "admin" => "optional:0"},
		    "ip" => {"#category_required" => 0,
			     "name" => "required",
			     "banned" => "optional:0",
			     "banned_time" => "optional:0"},
		    "anti_tk" => {"#category_required" => 0,
				  "initial_danger_period" => "optional:45",
				  "max_tk_score" => "optional:99",
				  "killer_revenge_no_points" => "optional:1",
				  "killer_revenge_bonus" => "optional:0",
				  "victim_revenge_bonus" => "optional:10",
				  "vigilante_timer" => "20",
				  "killer_vigilante_no_points" => "optional:1",
				  "killer_vigilante_bonus" => "optional:0",
				  "victim_vigilante_bonus" => "optional:30",
				  "consecutive_multiplier_bonus" => "optional:20",
				  "tk_ban" => "optional:300",
				  "admin_vigilante_points" => "optional:100",
				  "admin_revenge_points" => "optional:50"
			      },
		    "weapon_tk_points" => {"#category_required" => 0,
					   "colt" => "optional:50",
					   "luger" => "optional:50",
					   "knife" => "optional:50",
					   "knife_stealth" => "optional:50",
					   "explosive" => "optional:20",
					   "slime" => "optional:20",
					   "flamethrower" => "optional:30",
					   "grenade" => "optional:25",
					   "grenade_splash" => "optional:25",
					   "rocket" => "optional:25",
					   "rocket_splash" => "optional:25",
					   "machinegun" => "optional:20",
					   "mauser" => "optional:50",
					   "sniperrifle" => "optional:50",
					   "snooperscope" => "optional:50",
					   "garand" => "optional:50",
					   "lava" => "optional:20",
					   "mp40" => "optional:30",
					   "thompson" => "optional:30",
					   "sten" => "optional:30",
					   "venom" => "optional:30"},
		    "commands" => {"#category_required" => 0,
				   'regexp_matching' => 'optional:0',
			       },
					   
);


my %TranslateTeam = ("multi_axis", "Axis",
		     "multi", "Allies");

my %TranslateWeapon = ("MOD_COLT"=> "1911A1",
		       "MOD_EXPLOSIVE"=> "Explosive(?)",
		       "MOD_FLAMETHROWER"=> "Flamethrower",
		       "MOD_GARAND"=> "M1 Garand",
		       "MOD_GRENADE"=> "Grenade",
		       "MOD_GRENADE_SPLASH"=> "Grenade",
		       "MOD_KNIFE"=> "Knife",
		       "MOD_KNIFE_STEALTH"=> "Knife in the Back",
		       "MOD_LAVA"=> "Airstrike",
		       "MOD_LUGER"=> "Luger",
		       "MOD_MACHINEGUN"=> "Crew-served Machine Gun",
		       "MOD_MAUSER"=> "Mauser",
		       "MOD_MORTAR" => "Mortar",
		       "MOD_MORTAR_SPLASH" => "Mortar",
		       "MOD_MP40" => "MP-40",
		       "MOD_POISONGAS" => "Poison Gas",
		       "MOD_ROCKET" => "Panzerfaust",
		       "MOD_ROCKET_SPLASH" => "Panzerfaust",
		       "MOD_SLIME" => "TNT(?)",
		       "MOD_SNIPERRIFLE" => "Sniper Rifle",
		       "MOD_SNOOPERSCOPE" => "Snooper Scope",
		       "MOD_STEN" => "Sten Mk. II(S)",
		       "MOD_SUICIDE" => "Suicide",
		       "MOD_THOMPSON" => "Thompson SMG",
		       "MOD_UNKNOWN" => "Unkown",
		       "MOD_VENOM" => "Venom",
		       "MOD_ZOMBIESPIRIT" => "Zombie Spirit (??)",
		       "MOD_ZOMBIESPIT" => "Zombie Spit (??)");

my %NotVengenceWeapon = ("TNT" => 1,
			 "TNT(?)" => 1,
			 "Airstrike" => 1);

my %TranslateClass = ("redsoldier1" => "Soldier",
		      "redengineer1" => "Engineer",
		      "redlieutenant1" => "Lieutenant",
		      "redmedic1" => "Medic",
		      "bluesoldier1" => "Soldier",
		      "blueengineer1" => "Engineer",
		      "bluelieutenant1" => "Lieutenant",
		      "bluemedic1" => "Medic");

my %LogActionFunction = ("InitGame" => \&InitGame,
			 "ClientUserinfoChanged" => \&ClientUserInfoChanged,
			 "ClientDisconnect" => \&ClientDisconnect,
			 "ClientBegin" => \&ClientBegin,
			 "ClientConnect" => \&ClientConnect,
			 "say" => \&Say,
			 "sayteam" => \&SayTeam,
			 "Exit" => \&Exit,
			 "Kill" => \&Kill,
			 "Item" => \&Item);

my @SectionOrders = ("server", "anti_tk", "weapon_tk_points", "user", "ip");

my %SubOrders = ("server" => ["ip",
			      "oob_port",
			      "rcon",
			      "illegal_names",
			      "enforce_names",
			      "min_score",
			      "enforce_score",
			      "kick_users",
			      "motd",
			      "motd_frequency",
			      "poll_status_frequency",
			      "logfile",
			      "game_logfile",
			      "round_length",
			      "timeout",
			      "retry",
			      "restart_sleep",
			      "kill_server",
			      "disconnect_ban",
			      "kick_name_spammers",
			      "max_name_changes_per_second",
			      "reconnect_on_failure",
			      "kick_grenade_cheaters",
			      "grenade_cheat_ban_time",
			      "soldier_grenades",
			      "engineer_grenades",
			      "medic_grenades",
			      "lt_grenades",
			      "kick_names_with_leading_spaces",
			      "reconnect_sleep"],
		 "anti_tk" => ["initial_danger_period",
			       "killer_revenge_no_points",
			       "killer_revenge_bonus",
			       "victim_revenge_bonus",
			       "admin_revenge_points",
			       "vigilante_timer",
			       "killer_vigilante_no_points",
			       "killer_vigilante_bonus",
			       "victim_vigilante_bonus",
			       "admin_vigilante_points",
			       "consecutive_multiplier_bonus",
			       "tk_ban"],
		 "weapon_tk_points" => ["colt",
					"luger",
					"knife",
					"knife_stealth",
					"explosive",
					"slime",
					"flamethrower",
					"grenade",
					"grenade_splash",
					"rocket",
					"rocket_splash",
					"machinegun",
					"mauser",
					"sniperrifle",
					"snooperscope",
					"garand",
					"lava",
					"mp40",
					"thompson",
					"sten",
					"venom"],
		 "user" => ["name",
			    "ips",
			    "protect_nick",
			    "ignore_offenses",
			    "admin"],
		 "ip" => ["name",
			  "banned",
			  "banned_time"],
		 'commands' => ['regexp_matching',
				],
		 );

my %ConfigComments = 
    ("server" => 
     {"ip" => "#IP Address to connect to for Out of Band info:",
      "oob_port" => "#OOB Port to connect on:",
      "rcon" => "#RCON password to use:",
      "illegal_names" => "#Words you can't have in your name:",
      "enforce_names" => "#Set to 0 if you don't care what people have in their names:",
      "min_score" => "#Kick people with score less than this:",
      "enforce_score" => "#Whether or not to actually enforce the score minimum",
      "kick_user" => "#If set to 0, no users will ever be kicked (useful for testing):",
      "motd" => "#What the Message Of The Day is:",
      "motd_frequency" => "#How often to say the MOTD, in seconds; 0 if never:",
      "poll_status_frequency" => "#How often to poll for status information, in seconds.  You probably
#shouldn't mess with this:",
	  "logfile" => "#Log of the bot's activities:",
	  "game_logfile" => "#Input log used to actually run the bot:",
	  "round_length" => '#Round length, in minutes, or the word "default" to use the RTCW default:',
	  "timeout" => "#Communications timeout in seconds.  You probably shouldn't mess with this.",
	  "retry" => "#Number of times to retry on a timeout before deciding the server has had\n#a critical problem; 0 to retry infinitely",
	  "kill_server" => "#If 1, will try to figure out the server PID and kill it if the server\n#appears to be stuck.  WARNING:  THIS IS VERY EXPERIMENTAL!",
	  "disconnect_ban" => "#If > 0, will prevent users who disconnect from reconnecting for that number of\n#seconds.  This is useful in limited life games, to prevent people quitting\n#and reconnecting to get new lives.",
	  "kick_name_spammers" => "#If 1, will kick anyone who changes their name more often than\n#max_name_changes_per_second in a given second",
	  "max_name_changes_per_second" => "#If kick_name_spammers is 1, then will kick anyone who changes their name more\n#often than this",
	  "reconnect_on_failure" => "#If 1, will keep trying to reconnect whenever there is a critical problem",
	  "reconnect_sleep" => "#Seconds to sleep between reconnection attempts",
	  "kick_grenade_cheaters" => "#If 1, will kick users who throw more grenades in a life than their class\n#permits",
	  "grenade_cheat_ban_time" => "#Number of seconds to ban suspected grenade cheaters",
	  "soldier_grenades" => "#Number of grenades a soldier gets",
	  "engineer_grenades" => "#Number of grenades an engineer gets",
	  "medic_grenades" => "#Number of grenades a medic gets",
	  "lt_grenades" => "#Number of grenades a LT gets",
	  "kick_names_with_leading_spaces" => "#If 1, will kick people who have leading spaces in their names.\n#Such people tend to be troublemakers, and have put the space their to make it\n#harder to kick them from the console.",
	  "kick_voice_spammers" => "#If 1, will kick people who voice spam",
	  "max_voices_per_ten_seconds" => "#Maximum number of messages you can send per ten seconds",
	  "restart_sleep" => "#How long to sleep (in seconds) after killing the server, if kill_server is 1"
	  },
     "anti_tk" =>
     {"initial_danger_period" => '#Number of seconds a player new to the round is evaluated with a 
#much harsher set of rules (basically - within this danger period, TK
#points for people with no enemy kills are doubled).',
	  "max_tk_score" => "#Max TK points you can have without being killed",
	  "killer_revenge_no_points" => "#If Alice TKs Bob, and then Bob TKs Alice,
#should Bob get TK points?  The default (and recommended)
#is no:",
	  "killer_revenge_bonus" => "#Under the above scenario, should Bob get a bonus to his
#TK points?  The default (and recommended) is no:",
	      "victim_revenge_bonus" => "#Under the above scenario, should *Alice* get a bonus to her
#TK points?  The idea here is that, if you kill me, and the first
#thing I do when I come back is kill *you*, it makes it much more
#likely that *your* TK was intentional.",
		  "admin_revenge_points" => "#If the revenge killing is by an admin, make the bonus this, instead:
#Note that, if this is 0, the victim_revenge_bonus is used, instead",
		  
		  "vigilante_timer" => "#The following few deal with Vigilantism.  The idea here is,
#if Alice TKs Bob, and Charlie TKs Alice right after that, *and*
#Charlie hasn't TKed this round, it's MUCH more likely that
#Alice is an intentional TKer.

#What's the timer on Vigilantism?  Charlie has to kill Alice within
#this many seconds of her killing Bob.  Set to 0 if you want to ignore
#vigilantism.",
		  "killer_vigilante_no_points" => "#Should Charlie get points for killing Alice?  Default is no:",
		  "killer_vigilante_bonus" => "#Should Charlie get an additional bonus for killing Alice?  Default is
#no (remember bonuses are BAD things :):",
		      "victim_vigilante_bonus" => "#How many extra points should Alice get for being a suspected TKer?",
		      "admin_vigilante_points" => "#If the vigilante killing is by an admin, make the bonus this, instead:
#Note that, if this is 0, the victim_vigilante_bonus is used, instead",
		      "consecutive_multiplier_bonus" => "#What should the bonus be for consecutive TKs with no enemy kills?
#The way this works is, if consecutive_multiplier_bonus is
#20 (the default) in addition to whatever other bonus points
#may be racked up on a kill, the first kill gets no consecuctive
#points, the second kill gets +20, the third gets +40, the
#fourth gets +80, etc.  So, in example, if Alice is within
#intial_danger_period and has never killed an enemy, and
#is using the Thompson (default 30 points), her first TK
#is worth 60 points (30 * 2 for danger period).  Her second
#is worth another 80 points ((30 * 2) + 20).  Her third
#is worth another 100 points (30 * 2) + 40).  So, her total
#for #1 is 60, for #2 is 140, and for #3 is 240.  With the
#default max of 99, she'd be kicked after the second kill.
#In contrast, if it's 2 minutes in, and Alice has killed an enemy,
#and accidentally kills a friend with her Tommy gun, that's
#only 20 points.  If she then kills another enemy and then another
#friend walks in front of her, that's only 40 points.",
			  "tk_ban" => "#How long should TKers be banned for, in seconds?  This is ONLY people
#kicked for TKing (by score):"
},
"weapon_tk_points" =>
{"colt", "#TK points assigned for each weapon type.  The idea here is that
#weapons where you have to really be TRYING to kill someone make you
#much more likely to be an intentional TKer.

#Knives and Pistols are very hard to kill with:
",
"explosive" => "#TNT is relatively hard to kill with:",
"flamethrower" => "#Flamethrower it's pretty easy to kill with unintentionally, but it's
#a favorite of TKs.  Also, frankly, if you're that bad with it,
#don't use it.",
"grenade" => "#Fired or thrown explosives it's pretty easy to kill a lot of people
#with unintentionally:",
"machinegun" => "#Crew-mounted machine gun is very hard to TK intentionally with
#(and liable to get you vigilante-killed, anyway, since they know
#where you are):",
"mauser" => "#Sniper rifles are very hard to TK with without knowing you're killing
#friendlies.  \"Mauser\" is the unscoped shot for the
#axis and \"Garand\" is for the allies."},
'commands' => {'regexp_matching' => '#In various commands (such as "kick") if a / / is encountered, interpret as a regexp (rather than the usual substring matching).  Due to security concerns (which have yet to be resolved), this feature is not yet implemented' },);

my $TrailingComment = 
"#Users.  To force \"login\" from a given IP (so no one can impersonate
#the admin, for example) and in later releases, so the admin
#can do some extra stuff.  A sample user:
#[user]
#The nick to proect:
#name=Admin 
#IPs to allow login from - leave empty to effectively ban this person
#by nick:
#ips=127.0.0.1,127.0.0.2
#Set to 0 to not kick people who don\'t come from approved IP addresses:
#protect_nick = 0
#If 1, we ignore any rules this person breaks:
#ignore_offenses = 0
#If 1, the user is always a \"white hat\" for vigilantism, and may also
#get extra points tacked onto the people he vigilante or revenge kills
#(see anti_tk:admin_revenge_points), above
#admin = 0

#Uncomment this one to automatically kick anyone named \"Player\" :)
#[user]
#name=Player
#protect_nick = 1
#ignore_offenses = 0

#As well, you can ban by IP:
#[ip]
#name=127.0.0.1
#banned=1
";

my $Magic = "\377\377\377\377";

sub new
{
    my $proto = shift;
    my $class = ref($proto) || $proto;
    my $self  = {};
    $self->{"Config"} = undef;
    $self->{"Player"} = undef;
    $self->{"State"} = {"ReloadConfig" => 1,
			"LogFH" => undef,
			"ServerSocket" => undef,
			"LastMOTD" => time(),
			"LastPoll" => 0,
			"CarpedAboutDebugError" => 0,
			"CarpedAboutLogError" => 0,
			"Continue" => 1,
			"LastTimestamp" => 0,
			"LastRawTimestamp" => 0,
			"RoundStart" => 0,
			"PreviousRuns" => 0,
			"IsGhostRound" => 1,
			"NeedServerQuit" => 1,
			"NextIsGhostRound" => 0,
			"ConnectionTimedOut" => 0};
    bless ($self, $class);
    return $self;
}

sub ParseArgs
{
    my $self = shift || undef;
    my $ArgsIn = shift;
    my $Switches = shift;
    my @Argv = @_;
    my $ArgsOut = {};
    my $Result;

    $ArgsOut = $self->CopyHashRef($ArgsIn);

    my %ParsedSwitches;

    foreach my $Switch (keys(%{$Switches}))
    {
	my @SwitchNames = split(',', $Switch);
	for(my $x = 0; $x <= $#SwitchNames; ++$x)
	{
	    if($SwitchNames[$x] =~ /^.$/)
	    {
		$SwitchNames[$x] = "-$SwitchNames[$x]";
	    }
	    else
	    {
		$SwitchNames[$x] = "--$SwitchNames[$x]";
	    }
	    $ParsedSwitches{$SwitchNames[$x]} = $Switches->{$Switch};
	}
    }

    for(my $x = 0; $x <= $#Argv; ++$x)
    {
	my ($Lvalue, $Rvalue);

	#Ok, what type is it on the way in?  Three basic possibilities:
	#Either it's "-x", "-x=y" or "-x y" (considering "--xyz" for example,
	#to be the same thing)
	if($Argv[$x] =~ /^(.*)\=(.*)$/)
	{
	    #Ok, it needs a little work...
	    ($Lvalue, $Rvalue) = ($1, $2);
	}
	else
	{
	    $Lvalue = $Argv[$x];
	}

	#Should have a good lvalue, now.  Let's see if we know that arg:
	if(defined($ParsedSwitches{$Lvalue}))
	{
	    #Yup.  Does it require an rvalue?
	    if($ParsedSwitches{$Lvalue}{"type"} =~ /string/i)
	    {
		#Yup.  Do we have one?
		if(!defined($Rvalue))
		{
		    #Nope, not yet.
		    if($x <= $#Argv)
		    {
			#Yup, one in the next argument.
			$x++;
			$Rvalue = $Argv[$x];
		    }
		    else
		    {
			#Uh oh.
			#We'll catch it, below:
		    }
		}

		#Ok, let's try again.  do we have an rvalue?
		if(defined($Rvalue))
		{
		    $ArgsOut->{$ParsedSwitches{$Lvalue}{"action"}} = $Rvalue;
		}
		else
		{
		    $Result 
			.= "Argument \"$Rvalue\" requires an argument.\n";
		}
	    }
	    elsif($ParsedSwitches{$Lvalue}{"type"} =~ /bin/i)
	    {
		if($ParsedSwitches{$Lvalue}{"action"} =~ /^(.*)\=(.*)$/)
		{
		    $ArgsOut->{$1} = $2;
		}
		else
		{
		    $Result .= "Program error:  Unexpected action on " .
			"switch $Lvalue; action must be in form key=value\n";
		}
	    }
	    else
	    {
		$Result .= "Program error:  Unknown type " .
		    "$ParsedSwitches{$Lvalue}{type} on switch $Lvalue\n";
	    }
	}
	else
	{
	    $Result .= "Unknown argument $Lvalue\n";
	}
    }

    return($Result, $ArgsOut);
}

sub LoadConfigFile
{
    my $self = shift;
    my $ConfigFileName = shift || undef;
    my $Inf = gensym();
    my ($Category, %Keys);
    my $Result;
    my $TmpResult;

    $self->Log("Loading config file");

    if(!defined($ConfigFileName))
    {
	$self->{Config}{server} = {};
	$self->{Config}{anti_tk} = {};
	$self->{Config}{weapon_tk_points} = {};
	$self->{Config} = FillDefaults($self->{Config}, \%ConfigFields);
	return(1);
    }

    if(open($Inf, $ConfigFileName))
    {
	while(<$Inf>)
	{
	    chomp;
	    
	    s/^([^\#]*)\#.*$/$1/;
	    
	    if(/\S/)
	    {
		if(/^\s*\[([^\]]+)\]\s*$/)
		{
		    my $NewCategory = $1;
		    $NewCategory =~ tr/A-Z/a-z/;
		    if(defined($Category) &&
		       %Keys &&
		       (!defined($TmpResult = 
				 IsValid(\%ConfigFields, $Category, %Keys))))
		    {
			$Keys{"#category"} = $Category;
			
			if(defined($Keys{"name"}))
			{
			    %{$self->{Config}{$Category}{$Keys{"name"}}} = 
				%Keys;
			}
			else
			{
			    %{$self->{Config}{$Category}} = %Keys;
			}
		    }
		    elsif(defined($Category))
		    {
			$Result .= "Malformed record $Category; Ignoring\n";
		    }
		    $Result .= $TmpResult if($TmpResult);
		    $TmpResult = undef;
		    $Category = $NewCategory;
		    undef(%Keys);
		}
		elsif(/^\s*(\S+)\s*\=\s*(.*)\s*$/)
		{
		    my $Lvalue = $1;
		    my $Rvalue = $2;
		    
		    $Lvalue =~ tr/A-Z/a-z/;
		    
		    $Keys{$Lvalue} = $Rvalue;
		}
		else
		{
		    print STDERR "Malformed line at $ConfigFileName:$.:\n";
		    print STDERR "$_\n";
		    print STDERR "Ignoring.\n";
		}
	    }
	}
	
	if(defined($Category) &&
	   %Keys &&
 	   (!defined($TmpResult = 
		     IsValid(\%ConfigFields, $Category, %Keys))))
	{
	    $Keys{"#category"} = $Category;
			
	    if(defined($Keys{"name"}))
	    {
		%{$self->{Config}{$Category}{$Keys{"name"}}} = 
		    %Keys;
	    }
	    else
	    {
		%{$self->{Config}{$Category}} = %Keys;
	    }
	}
	$Result .= $TmpResult if($TmpResult);
	$TmpResult = undef;
	
	$self->{Config} = FillDefaults($self->{Config}, \%ConfigFields);

	close($Inf);

	#We have to fields that should be arrays, if we have them as lists:
	if(defined($self->{Config}{server}{"illegal_names"}))
	{
	    my $Tmp = $self->{Config}{server}{"illegal_names"};
	    delete($self->{Config}{server}{"illegal_names"});
	    @{$self->{Config}{server}{"illegal_names"}} = 
		split(',', $Tmp);
	}

	#And, users can have a list of IPs it's OK for them to connect
	#from:
	foreach my $Name (keys(%{$self->{Config}{user}}))
	{
	    if(defined($self->{Config}{user}{$Name}{ips}))
	    {
		my $Tmp = $self->{Config}{user}{$Name}{ips};
		delete($self->{Config}{user}{$Name}{ips});
		@{$self->{Config}{user}{$Name}{ips}} = 
		    split(',', $Tmp);
	    }
	}

	$self->AnalyzeConfiguration();
    }
    else
    {
	$Result = "Unable to open $ConfigFileName:  $!";
    }
	
    return($Result);
}

sub SaveConfigFile
{
    my $self = shift;
    my $FH = shift || *STDOUT;
    my @Order;
    my $FirstSection = 1;
       
    if(@_)
    {
        @Order = @_;
    }
    else
    {
        @Order = @SectionOrders;
    }

    foreach my $Section (@Order)
    {
        print "\n" if(!$FirstSection);
        $FirstSection = 0 if($FirstSection);
        #Two types, here - either straight hashes or hashes of hashes.
        #Let's figure out what we want...
        my @SubKeys = keys(%{$self->{Config}{$Section}});

        if(ref($self->{Config}{$Section}{$SubKeys[0]}))
        {
            #It's a sub-key-ref-thing...
            foreach my $SubKey (@{$SubOrders{$Section}})
            {
                print $FH "[$Section]\n";
                foreach my $SubSubKey (keys(%{$self->{Config}{$Section}{$SubKey}}))
                {
                    print $FH "$SubKey = ";
                    if(defined($self->{Config}{$Section}{$SubKey}{$SubSubKey}))
                    {
                        print {$FH}
                        $self->{Config}{$Section}{$SubKey}{$SubSubKey};
                    }
                    print $FH "\n";
                }
            }
        }
        else
        {
            print $FH "[$Section]\n";
            foreach my $SubKey (@{$SubOrders{$Section}})
            {
		if(defined($ConfigComments{$Section}{$SubKey}))
		{
		    print {$FH} $ConfigComments{$Section}{$SubKey} . "\n";
		}
                print $FH "$SubKey = ";
                if(defined($self->{Config}{$Section}{$SubKey}))
                {
		    if(ref($self->{Config}{$Section}{$SubKey}) eq "ARRAY")
		    {
			my @TmpArray = @{$self->{Config}{$Section}{$SubKey}};
			for(my $x = 0; $x <= $#TmpArray; ++$x)
			{
			    print {$FH} "," if($x > 0);
			    print {$FH} "$TmpArray[$x]";
			}
			print {$FH} "\n";
		    }
		    else
		    {
			print {$FH} $self->{Config}{$Section}{$SubKey}
		    }
                }
                print {$FH} "\n\n";
            }
        }
    }

    if(defined($TrailingComment))
    {
	print {$FH} "\n$TrailingComment\n";
    }
}
    
sub CopyHashRef
{
    shift if($#_ == 1); #Ignore OO
    my $Dest = {};
    my $Src = shift;

    foreach my $Key (keys(%{$Src}))
    {
	if(ref($Src->{$Key}) eq "HASH")
	{
	    $Dest->{$Key} = CopyHashRef($Src->{$Key});
	}
	elsif(ref($Src->{$Key}) eq "ARRAY")
	{
	    $Dest->{$Key} = CopyArrayRef($Src->{$Key});
	}
	else
	{
	    $Dest->{$Key} = $Src->{$Key};
	}
    }

    return($Dest);
}

sub CopyArrayRef
{
    shift if($#_ == 1); #Ignore OO
    my $Dest = ();
    my $Src = shift;

    my @TmpArray = @{$Src};

    for(my $x = 0; $x <= $#TmpArray; ++$x)
    {
	if(ref($TmpArray[$x]) eq "HASH")
	{
	    push(@{$Dest}, CopyHashRef($TmpArray[$x]));
	}
	elsif(ref($TmpArray[$x] eq "ARRAY"))
	{
	    push(@{$Dest}, CopyArrayRef($TmpArray[$x]));
	}
	else
	{
	    push(@{$Dest}, $TmpArray[$x]);
	}
    }

    return($Dest);
}

sub DumpThings
{
    #Let's ignore a $self if we got one:
    if(ref($_[0]) eq "Wab")
    {
	shift;
    }
    if($#_ >= 0)
    {
	return(_DumpThings(\*STDERR, 0, 0, @_));
    }
}

sub _DumpThings
{
    my $OutputFH = shift;
    my $DoTabs = shift;
    my $Level = shift;

    foreach my $Thing (@_)
    {
	if(ref($Thing) eq "ARRAY")
	{
	    my @TmpThing = @{$Thing};
	    for(my $x = 0; $x <= $#TmpThing; ++$x)
	    {
		_PrintTabs($OutputFH, $Level) if($DoTabs);
		$DoTabs = 1;
		print {$OutputFH} "$x =\t";
		_DumpThings($OutputFH, 0, $Level + 1, $TmpThing[$x]);
	    }
	}
	elsif(ref($Thing) eq "HASH")
	{
	    foreach my $x (sort(keys(%{$Thing})))
	    {
		_PrintTabs($OutputFH, $Level) if($DoTabs);
		$DoTabs = 1;
		print {$OutputFH} "$x =\t";
		_DumpThings($OutputFH, 0, $Level + 1, $Thing->{$x});
	    }
	}
	else
	{
	    _PrintTabs($OutputFH, $Level) if($DoTabs);
	    if(defined($Thing))
	    {
		print {$OutputFH} "$Thing";
	    }
	    
	    print {$OutputFH} "\n";
	}
    }
}

sub _PrintTabs
{
    my $self;
    $self = shift if($#_ == 3);

    my $FH = shift;
    my $NumTabs = shift;

    for(my $x = 0; $x < $NumTabs; ++$x)
    {
	print {$FH} "\t";
    }
}

sub FillDefaults
{
    my $Config = shift;
    my $ConfigFields = shift;

    foreach my $Category (keys(%{$Config}))
    {
	my $Type = "Individual";
	
	foreach my $Record (keys(%{$Config->{$Category}}))
	{
	    #This is either a record in and of itself, or a hash of a bunch
	    #of records. 

	    if(ref($Config->{$Category}{$Record}) eq "HASH")
	    {
		$Type = "Multiple";
		#It's a hash of a bunch of records.  Let's get the defaults
		#for this category:
		foreach my $Option (keys(%{$ConfigFields->{$Category}}))
		{
		    $Config->{$Category}{$Record}{$Option} =
			FillDefault($Config->{$Category}{$Record}{$Option},
				    $ConfigFields->{$Category}{$Option});
		    
 		}
	    }
	}

	if($Type eq "Individual")
	{
	    foreach my $Option (keys(%{$ConfigFields->{$Category}}))
	    {
		$Config->{$Category}{$Option} =
		    FillDefault($Config->{$Category}{$Option},
				$ConfigFields->{$Category}{$Option});
		
	    }
	}
    }

    return($Config);
}

sub FillDefault
{
    my $Arg = shift;
    my $Default = shift;

#    print STDERR "\<$Arg\>  \<$Default\>\n";

    if(!defined($Arg))
    {
	if($Default =~ /^optional:(.*)/)
	{
	    if(length($1))
	    {
		$Arg = $1;
	    }
	}
	elsif($Default =~ /^required/)
	{
#	    $Arg = $Arg;
	}
	else
	{
	    $Arg = $Default;
	}
    }

    return($Arg);
}

sub IsValid
{
    my ($ConfigFields, $Category, %Record) = @_;
    my $IsValid;

    foreach my $Key (keys(%Record))
    {
	if(!defined($ConfigFields->{$Category}{$Key}))
	{
	    $IsValid .= "Unknown lval $Key in [$Category]\n";
	}
    }

    foreach my $Key (keys(%{$ConfigFields->{$Category}}))
    {
	if($ConfigFields->{$Category}{$Key} eq "required" &&
	   (!defined($Record{$Key})))
	{
	    $IsValid .= "Missing required field $Key in [$Category]\n";
	}
    }

    return($IsValid);
}

sub MergeArgs
{
    my $self = shift;
    my $Args = shift;

    foreach my $Key (keys(%{$Args}))
    {
	$self->{Config}{"#args"}{$Key} = $Args->{$Key};
    }

    #Special case - are we in logfile test mode?
    if(defined($self->{Config}{"#args"}{logfile_test}))
    {
	$self->{Config}{"#args"}{do_stat} = 0;
	$self->{Config}{"#args"}{test_mode} = 1;
    }
}

sub ReloadConfig
{
    my $self = shift;
    if($#_ == 0)
    {
	$self->{"State"}{"ReloadConfig"} = $_[0];
    }
    
    return($self->{"State"}{"ReloadConfig"});
}

sub Continue
{
    my $self = shift;
    if($#_ == 0)
    {
	$self->{"State"}{"Continue"} = $_[0];
	$self->DebugLog("Setting continue to $self->{State}{Continue}");
    }
    
    return($self->{"State"}{"Continue"});
}

#Open a log file for tailing
sub OpenGameLogFile
{
    my $self = shift;
    my $RC = undef;

    #Make sure we're not being called with a logfile already open...
    if(!defined($self->{"State"}{"LogFH"}))
    {
	my $Logfile = $self->{"Config"}{"#args"}{logfile_test} ||
			$self->{"Config"}{"server"}{"game_logfile"};
	$self->DebugLog("Opening Game Log File $Logfile");
	$self->{"State"}{"LogFH"} = gensym();
	if(open($self->{"State"}{"LogFH"}, $Logfile))
	{
	    #Do we need to seek to the end?
	    if(!defined($self->{Config}{"#args"}{logfile_test}))
	    {
		SeekToEnd($self->{"State"}{"LogFH"});
	    }
	}
	else
	{
	    $RC = "Unable to read " .
		"$Logfile: $!";
	}
    }
    else
    {
	$self->DebugLog("Logfile already open!");
    }

    return($RC);
}

#Close a game log
sub CloseGameLogFile
{
    my $self = shift;

    if(defined($self->{State}{LogFH}))
    {
	close($self->{"State"}{"LogFH"});
	$self->{State}{LogFH} = undef;
    }
}

sub ServerConnect
{
    my $self = shift;
    my $RC = undef;
    
    return($RC) if(!$self->Continue() ||
		   !$self->{Config}{"#args"}{do_stat});
    
    $self->Log("PID $$ Connecting to server");
    #Ignore if we already have a connection...
    if(!defined($self->{"State"}{"ServerSocket"}))
    {
	if(defined($self->{"State"}{"ServerSocket"} = 
		 IO::Socket::INET->new("PeerAddr" => 
				       $self->{"Config"}{"server"}{"ip"},
				       "PeerPort" =>
				       $self->{"Config"}
				       {"server"}{"oob_port"},
				       "Proto" => "udp",
				       "Timeout" => $self->{Config}{server}{timeout})))
	{
	    $self->{State}{ServerSocket}->timeout($self->{Config}{server}{timeout});
	    $self->DebugLog("Setting ConnectionTimedOut to 0 ServerConnect");
	    $self->{State}{ConnectionTimedOut} = 0;
	    
	    $self->{"State"}{"ServerSocket"}->autoflush(1);
	    #Execute an arbitrary command to see if we're OK
	    
	    my @Result = $self->RCONCmd(1, "timelimit");
	    
	    if($#Result >= 0)
	    {
		if($Result[0] =~ /timelimit/)
		{
		    #All OK...
		    $RC = undef;
		    sleep(1);
		}
		elsif($Result[0] =~ /Bad rconpassword/)
		{
		    $RC = "Incorrect RCON password";
		}
		else
		{
		    $RC = "Connection made, but unexpected server response:  " .
			join(" ", @Result);
		}
	    }
	    else
	    {
		if($self->{State}{ConnectionTimedOut})
		{
		    $RC = "Server is not running on " .
			$self->{Config}{server}{ip} . ":" .
			    $self->{Config}{server}{oob_port};
		}
		else
		{
		    $RC = "Unable to connect to " .
			$self->{Config}{server}{ip} . ":" .
			    $self->{Config}{server}{oob_port} . ":  $!";
		}
		$self->Continue(0);
	    }
	}
	else
	{
	    $RC = "IO::Socket->new failed for " .
		$self->{Config}{server}{ip} . ":" .
		    $self->{Config}{server}{oob_port} . ":  $!";
	    $self->Continue(0);
	}
    }
    else
    {
	carp "Already have server connection!";
    }

    return($RC);
}

sub ServerDisconnect
{
    my $self = shift;
    my $RC = 1;

    $self->Log("Disconnecting from server");

    #Silently succeed if we're already disconnected
    if(defined($self->{"State"}{"ServerSocket"}))
    {
	close($self->{"State"}{"ServerSocket"});
	$self->{"State"}{"ServerSocket"} = undef;
    }

    return($RC);
}

sub GetLogBacklog
{
    my $self = shift;
    my $LogBuffer = undef;

    if(defined($self->{"State"}{"LogFH"}))
    {
	my $MaxLines = 100;
	my $LinesRead = 0;
	my $KeepReading = 1;
	my $EndTime = $self->NextOOBEventTime();
	my $TmpBuffer;

	do
	{
	    if(!defined($TmpBuffer = readline($self->{"State"}{"LogFH"})))
	    {
		#Ok, nothing more to read.  Are we in test mode?  If so,
		#this is the end of the road...
		if(defined($self->{Config}{'#args'}{logfile_test}))
		{
		    $self->Continue(0);
		    $KeepReading = 0;
		}
		else
		{
		    #We're not in test mode.  Have we gotten a line, yet?
		    if($LinesRead)
		    {
			$KeepReading = 0;
			#Yup.  That's good enough, let's bail
		    }
		    else
		    {
			#Nope.
			#Ok, let's reset the file pointer and
			#sleep for a second:
			ResetFH($self->{State}{LogFH});
			sleep(1);
		    }
		}
	    }
	    else
	    {
		$LogBuffer .= $TmpBuffer;
		++$LinesRead;
	    }
	}while(($LinesRead < $MaxLines) &&
	       ($KeepReading) &&
	       (time() < $EndTime));
 
#	$self->DebugLog("Read $LinesRead lines: $KeepReading $EndTime " . 
#			time());
    }
    else
    {
	carp "Config::State::LogFH is nil:  Huh?";
    }

    my @LogBuffer;

    if(defined($LogBuffer))
    {
	@LogBuffer = split('\n', $LogBuffer);
    }

    return(@LogBuffer);
}

sub NextOOBEventTime
{
    my $self = shift;
    my $Now = time();

    my @Events;
    push(@Events, $self->{"State"}{"LastMOTD"} + 
	 $self->{"Config"}{"server"}{"motd_frequency"});
    push(@Events, $self->{"State"}{"LastPoll"} +
	 $self->{"Config"}{"server"}{"poll_status_frequency"});

    my $NextEvent = $Events[0];

    for(my $x = 0; $x <= $#Events; ++$x)
    {
	if($Events[$x] < $NextEvent)
	{
	    $NextEvent = $Events[$x];
	}
    }

    $NextEvent = $Now if($NextEvent < $Now);

#    $self->DebugLog("Next OOB Event will be at $NextEvent");
	
    return($NextEvent);
}

sub DebugLog
{
    my $self = shift;

    if(ref($self))
    {
	if($self->{Config}{"#args"}{debug} &&
	   defined($self->{Config}{server}{debug_logfile}))
	{
	    my $OUF = gensym();
	    if(open($OUF, ">>$self->{Config}{server}{debug_logfile}"))
	    {
		my $Timestamp = localtime(time());
		my $Line = "";
		
		foreach my $Var (@_)
		{
		    if(defined($Var))
		    {
			$Line .= "$Var";
		    }
		    $Line .= " ";
		}
		chop($Line);
		print {$OUF} "$Timestamp:$self->{State}{LastRawTimestamp}:$Line\n";
		close($OUF);
	    }
	    elsif(!$self->{"State"}{"CarpedAboutDebugError"})
	    {
		$self->{"State"}{"CarpedAboutDebugError"} = 1;
		carp "Unable to open $self->{Config}{server}{debug_logfile}" .
		    " for writing:  $!";
	    }
	}
	
    }
    else
    {
	carp "DebugLog called not as object!";
    }
}

sub Log
{
    my $self = shift;

    if(ref($self))
    {
	if(defined($self->{Config}{server}{logfile}))
	{
	    my $OUF = gensym();
	    if(open($OUF, ">>$self->{Config}{server}{logfile}"))
	    {
		my $Timestamp = localtime(time());
		my $Line = join(' ', @_);
		print {$OUF} "$Timestamp:$self->{State}{LastRawTimestamp}:$Line\n";
		close($OUF);
	    }
	    elsif(!$self->{"State"}{"CarpedAboutLogError"})
	    {
		$self->{"State"}{"CarpedAboutLogError"} = 1;
		carp "Unable to open $self->{Config}{server}{logfile}" .
		    " for writing:  $!";
	    }
	}
	
    }
    else
    {
	carp "DebugLog called not as object!";
    }
}

sub ProcessLog
{
    my $self = shift;
    my @LogBuffer = @_;

    if($#LogBuffer >= 0)
    {
	for(my $x = 0; $x <= $#LogBuffer; ++$x)
	{
	    $self->ProcessLine($LogBuffer[$x]);
	}
    }
}

sub ProcessLine
{
    my $self = shift;
    chomp(my $Line = shift);
    my $CheckStatNeed = shift;
    my $ReturnCode = 0;

    if(my($RawTimestamp, $Type) = 
       ($Line =~ /^\s*(\d+\:\d\d)\s*(.*)$/))
    {
	my $Timestamp;
	
	$Timestamp = $self->ParseTimestamp($RawTimestamp);
	$self->{State}{LastRawTimestamp} = $RawTimestamp || 0; 
	#Mostly for debugging
	
	if($Type =~ /^([^\:]+)\: (.*)$/)
	{
	    my $Function = $1;
	    my $Args = $2;

#	    $self->DebugLog("Timestamp = $Timestamp; Function = $Function");
	    if(defined($LogActionFunction{$Function}))
	    {
		$ReturnCode = 
		    &{$LogActionFunction{$Function}}($self,
						     $Timestamp, 
						     $Args, $CheckStatNeed);
	    }
	}
    }
    return($ReturnCode);
}

sub ParseTimestamp
{
    my $self = shift;
    my $RawTimestamp = shift;
    my $Timestamp;
    
    my ($Minutes, $Seconds) = ($RawTimestamp =~ /^(\d+)\:(\d+)$/);
    
    if($RawTimestamp =~ /^\s*0\:00/)
    {
	#New round
	$self->{"State"}{"PreviousRuns"} += $self->{"State"}{"LastTimestamp"};
    }
    $Timestamp = ($Minutes * 60) + $Seconds + $self->{"State"}{"PreviousRuns"};
    
    $self->{"State"}{"LastTimestamp"} = $Timestamp;

    return($Timestamp);
}

sub Stat
{
    my $self = shift;
    my @Players;

    return if(!$self->{Config}{"#args"}{do_stat});


#    $self->DebugLog("Entering Stat");

    if(!$self->Continue())
    {
	$self->DebugLog("Exiting stat because Continue() returned 0");
	return(0);
    }

    $self->{"State"}{"LastPoll"} = time();

    if($self->{"#args"}{"no_stat"})
    {
	$self->DebugLog("Exiting stat because #args->no_stat is true");
	return(0);
    }
    
    my @Response;

    @Response = $self->RCONCmd(1, "status");

#    $self->DebugLog("Got $#Response lines back from status command");

    for(my $x = 0; $x <= $#Response; ++$x)
    {
	my @Fields;
	@Fields = split("\t", $Response[$x]);

	if($#Fields < 7)
	{
	    #So, the new Linux wolf uses "fixed length" fields, instead of tab 
	    #delimiters.  What's it do if a field is too long?  IT OVERFLOWS!
	    #F'n brilliant.  Thankfully, since the name is the only field that
	    #will overflow, it's reasonably easy to fix (in perl):
	    @Fields = ($Response[$x] =~ 
		       /^(.{3})(.{6})(.{6})(.*)(.{7})(.{22})(.{6})(.{6})\s*$/);
	}
#	$self->DebugLog("status line: ($#Fields) \<$Response[$x]\>");
	for(my $x = 0; $x <= $#Fields; ++$x)
	{
	    if($x != 3) 
	    {
		#Don't strip leading and trailing space from names; we need
		#that, later
		$Fields[$x] = StripLeadingAndTrailingWhiteSpace($Fields[$x]);
	    }
	}
	if($self->IsStatPlayer(@Fields))
	{
	    if($self->CreateOrUpdateClientInfo($self->{State}{LastTimestamp},
					       @Fields))
	    {
		$self->ProcessLogin($Fields[0]);
	    }
	}
    }

    return(1);
}

sub GetServerResponse
{
    my $self = shift;
    my $BlockInitially = shift || 0;
    my $BlockTime = $self->{config}{server}{timeout} || .2;
    my $Socket = shift || $self->{"State"}{"ServerSocket"};
    my $CharsRead = undef;
    my $TmpBuffer = "";
    my @Buffer;
    my $CurrentLine;
    my $Pattern = "^$Magic" . "print\n";
    my $FirstRun = 1;
    my $TotalCharsRead = 0;

    my $Select = IO::Select->new($Socket);

    #We only are going to see a BlockInitially = 1 when the client is
    #_expecting_ a response.  So, if we're blocking and the request times out,
    #it probably means something went wrong - i.e., the server is whacked.

    $BlockTime = 0 if(!$BlockInitially);

    while(my @Sockets = $Select->can_read($BlockTime))
    {
	foreach $Socket (@Sockets)
	{
	    if(defined($CharsRead = $Socket->sysread($TmpBuffer, 65507)))
	    {
		$TotalCharsRead += $CharsRead;
		$TmpBuffer =~ s/$Pattern//;	
		if($TmpBuffer !~ /^ $/)
		{
		    my @Lines = (split("\n", $TmpBuffer));
		    if($#Lines > 0)
		    {
			#We're on Linux, where it all comes back at once
			push(@Buffer, (split("\n", $TmpBuffer)));
		    }
		    else
		    {
			#We're on Windows, where it comes back in pieces

			my $HadNewline = 0;
			if($TmpBuffer =~ /[\n\r]$/m)
			{
			    $HadNewline = 1;
			}
			
			$TmpBuffer =
			    StripLeadingAndTrailingWhiteSpace($TmpBuffer);
			
			$CurrentLine .= $TmpBuffer;
			
			if(!$HadNewline)
			{
			    $CurrentLine .= "\t";
			}
			else
			{
			    push(@Buffer, $CurrentLine);
			    $CurrentLine = undef;
			}
		    }
		}
	    }
	}
    }

    #Add on any trailing lines
    if(defined($CurrentLine))
    {
	push(@Buffer, $CurrentLine);
    }
    
    if(!$TotalCharsRead && $BlockInitially)
    {
	#Uh-oh.  We were expecting a response and didn't get one. 
	#That should be the server is borked...
	$self->{State}{ConnectionTimedOut} = 1;
	$self->DebugLog("Setting ConnectionTimedOut to 1 in GetServerResponse");
    }

    return(@Buffer);
}

sub PeriodicStat
{
    my $self = shift;
    my $ReturnCode = 1;

#    $self->DebugLog("PeriodicStat -",
#		    $self->{State}{LastPoll},
#		    $self->{"State"}{"LastPoll"},
#		    $self->{"Config"}{"server"}{"poll_status_frequency"},
#		    time());
    
    if((!$self->{"State"}{"LastPoll"}) ||
       $self->{"State"}{"LastPoll"} + 
       $self->{"Config"}{"server"}{"poll_status_frequency"} <=
       time())
    {
	$ReturnCode = $self->Stat();
    }

    return($ReturnCode);
}

sub MOTD
{
    my $self = shift;
    my $ReturnCode = 1;

    if(($self->{"Config"}{"server"}{"motd_frequency"} > 0) &&
       ((!$self->{"State"}{"LastMOTD"}) ||
	($self->{"State"}{"LastMOTD"} + 
	 $self->{"Config"}{"server"}{"motd_frequency"} <=
	 time())))
    {
	$self->{"State"}{"LastMOTD"} = time();
	if(!$self->{Config}{"#args"}{"test_mode"})
	{
	    $self->BroadcastMessage($self->{Config}{server}{motd});
	}
	$self->DebugLog("Sending MOTD, Last = $self->{State}{LastMOTD}; " .
			"Freq = " .
			$self->{"Config"}{"server"}{"motd_frequency"});
    }

    return($ReturnCode);
}

#This is a euphemistic way of saying "kick people" :)
sub TakeAction
{
    my $self = shift;
    my $DoCopiusTADebug = 0;

    #Set the 0 to 1 for ludicrous amounts of kick-related debugging
    if(0)
    {
	if((!$self->{"State"}{LastCopiusTADebug}) ||
	   $self->{"State"}{LastCopiusTADebug} + 5 <=
	   time())
	{ 
	    $self->{State}{LastCopiusTADebug} = time();
	    $DoCopiusTADebug = 1;
	}
    }

    foreach my $Client (keys(%{$self->{Player}}))
    {
	my $TempBanableKick = 0;

	#However, we don't kick people who haven't been logged in,
	#yet, because they might be people who have immunity.
	if($DoCopiusTADebug)
	{
	    $self->DebugLog("TA",
			    $Client,
			    $self->{Player}{$Client}{name},
			    $self->{Player}{$Client}{kicked},
			    $self->{Player}{$Client}{logged_in},
			    $self->{Player}{$Client}{illegal_name},
			    $self->{Player}{$Client}{score}, 
			    $self->{Config}{server}{min_score},
			    $self->{Player}{$Client}{tk_score},
			    $self->{Config}{anti_tk}{max_tk_score},
			    $self->{Player}{$Client}{ip});
	}

	if((!$self->{Player}{$Client}{kicked}) &&
	   (defined($self->{Player}{$Client}{logged_in}) ||
	   $self->{Config}{'#args'}{test_mode}))
	{
	    my $KickClient = 0;
	    my $KickReason = undef;
	    my $KickBroadcast = undef;

	    #Is this player logged in _properly_?
	    if(defined($self->{Player}{$Client}{logged_in}) &&
	       $self->{Player}{$Client}{logged_in} eq "failed")
	    {
		$KickClient = 1;
		$KickReason = "Failed login (";
		$KickReason .= $self->{Player}{$Client}{ip} if defined $self->{Player}{$Client}{ip};
		$KickReason .= ')';
		$KickBroadcast = "Name not valid from that IP";
	    }
	    elsif($self->{Player}{$Client}{illegal_name})
	    {
		#Name that's prohibited
		$KickClient = 1;
		$KickReason = "Illegal Name:  " . 
		    $self->{Player}{$Client}{illegal_name};
		$KickBroadcast = "Name not allowed";
	    }
	    elsif(defined($self->{Player}{$Client}{score}) &&
		  $self->{Player}{$Client}{score} < 
		  $self->{Config}{server}{min_score})
	    {
		if($self->{Config}{server}{enforce_score} &&
		   !$self->{Player}{$Client}{ignore_offenses})
		{
		    $KickClient = 1;
		    $KickReason = "Score $self->{Player}{$Client}{score} < " .
			$self->{Config}{server}{min_score};
		    $KickBroadcast = "Score too low";
		}
		else
		{
		    $self->DebugLog("Would've kicked",
				    "$self->{Player}{$Client}{name} (Client)",
				    "for score",
				    $self->{Player}{$Client}{score},
				    " < $self->{Config}{server}{min_score},",
				    "except enforce_score =\<" .
				    $self->{Config}{server}{enforce_score}.
				    "\> &&",
				    "Ignore Offenses = \<" .
				    $self->{Player}{$Client}{ignore_offenses},
				    "\>");
		}
	    }
	    elsif(defined($self->{Player}{$Client}{tk_score}) &&
		  $self->{Player}{$Client}{tk_score} > 
		  $self->{Config}{anti_tk}{max_tk_score} &&
		  !$self->{Player}{$Client}{ignore_offenses})
	    {
		$KickClient = 1;
		$KickReason = "TK Score $self->{Player}{$Client}{tk_score} > ".
		    $self->{Config}{anti_tk}{max_tk_score};
		$KickBroadcast = "Team Killing";
		$TempBanableKick = 1;
	    }
	    elsif($self->{Player}{$Client}{banned})
	    {
		$KickClient = 1;
		if(defined($self->{Player}{$Client}{banned_time}) &&
		   $self->{Player}{$Client}{banned_time} > 0)
		{
		    $KickReason = "Banned until " .
			"$self->{Player}{$Client}{banned_time} ".
			    "(is now " . time() . ").";
		    my $Secs = $self->{Player}{$Client}{banned_time} - time();
		    $KickBroadcast = "Banned for $Secs seconds";
		}
		else
		{
		    $KickReason = "Permanently banned";
		    $KickBroadcast = "Permanently banned";
		}
	    }

	    if($TempBanableKick &&
	       $self->{Config}{anti_tk}{tk_ban} &&
	       defined($self->{Player}{$Client}{ip}))
	    {
		$self->Ban($Client,
			   $self->{Config}{anti_tk}{tk_ban},
			   "TK");
	    }
	    
	    if($KickClient)
	    {
		$self->Kick($Client, $KickReason, $KickBroadcast);
	    }
	}
    }

    return(1);
}

sub InitGame
{
    my $self = shift;
    my $Timestamp = shift;
    my $Args = shift;

    $self->DebugLog("Entering Init Game:  IsGhostRound = ",
		    $self->{State}{IsGhostRound},
		    " NextIsGhostRound = ",
		    $self->{State}{NextIsGhostRound});
    #Ok, start of a new game.  Is this going to be a ghost round?
    $self->{State}{IsGhostRound} = $self->{State}{NextIsGhostRound};
    
    $self->{State}{RoundStart} = $Timestamp;
    
    #We know the NEXT round will be real:
    $self->{State}{NextIsGhostRound} = 0;
    $self->DebugLog("Leaving Init Game:  IsGhostRound = ",
		    $self->{State}{IsGhostRound},
		    " NextIsGhostRound = ",
		    $self->{State}{NextIsGhostRound});
    if(!$self->{State}{IsGhostRound})
    {
	$self->Log("Round Start");
	foreach my $Client (keys(%{$self->{Player}}))
	{
	    $self->ResetClientInfo($Client, $Timestamp);
	}
	
	if(defined($self->{Config}{server}{round_length}) &&
	   $self->{Config}{server}{round_length} =~ 
	   /^\s*[\d\.]+\s*$/)
	{
	    $self->DebugLog("Setting timelimit to",
			    "\<$self->{Config}{server}{round_length}\>");
	    $self->RCONCmd(0, "timelimit " .
			   $self->{Config}{server}{round_length});
	}
	
	#And, let's se the wab_version
	$self->SetWABVersion();
    }
}

sub ClientUserInfoChanged
{
    my $self = shift;
    my $Timestamp = shift;
    my $Args = shift;
    my $OldName;

#    $self->DebugLog("CUIC \<$Args\>");

    if(my ($Client, $Name, $Team, $Class) = 
       ($Args =~ 
	/^\s*(\d+)\s+n\\(.*)\s*\\t\\\d+\\(?:model|m)\\([^\\]+)\/([^\\\/]+)[\\\/]/))
    {
	$Team = TranslateTeam($Team);
	$Class = TranslateClass($Class);
	
	my $RawName = $Name;

	$Name = StripNameControlCodes($Name);
	$Name = StripLeadingAndTrailingWhiteSpace($Name);
	
	
	if(!defined($self->{Player}{$Client}))
	{
	    $self->DebugLog("CUIC New Client");
	    #Must've come in in the middle of something.  Well, let's
	    #muddle through as best we can...
	    $self->CreateOrUpdateClientInfo($Timestamp, 
					    $Client);
	}
	else
	{
	    $OldName = $self->{Player}{$Client}{raw_name};
	}

	if(defined($OldName) &&
	   defined($RawName) &&
	   ($OldName ne $RawName))
	{
	    #It's a name change.  Do we care?
	    if($self->{Config}{server}{kick_name_spammers})
	    {
		#Yes, we do.  Get the timestamp...
		#Is this the same timestamp as the last time he changed his
		#name?
		if(defined($self->{Player}{$Client}{last_namechange}) &&
		   ($self->{Player}{$Client}{last_namechange} ==
		    $Timestamp))
		{
		    #Yes, it is.
		    ++$self->{Player}{$Client}{namechange_counter};

		    #Is that more times/second than allowed?
		    if($self->{Player}{$Client}{namechange_counter} >
		       $self->{Config}{server}{max_name_changes_per_second})
		    {
			#Yes, it is.  Kick!
			$self->Kick($Client,
				    "Name spamming",
				    "Name spamming");
		    }
		}
		else
		{
		    #Different timestamp (or first time changed).  Note it:
		    $self->{Player}{$Client}{last_namechange} = $Timestamp;
		    $self->{Player}{$Client}{namechange_counter} = 0;
		}
	    }
	}
	
	$self->DebugLog("Client $Client",
			"updated info to $Name $Team $Class \<$RawName\>");
	
	$self->LogUserInfoChange($Client, $Name, $Team, $Class);

	$self->{Player}{$Client}{"raw_name"} = $RawName;
	$self->{Player}{$Client}{"name"} = $Name;
	$self->{Player}{$Client}{"team"} = $Team;
	$self->{Player}{$Client}{"class"} = $Class;
	$self->{Player}{$Client}{"max_possible_grenades"} =
	    $self->ClassGrenadeLimits($self->{Player}{$Client}{class});
	    

	if((!defined($OldName) ||
	    ($OldName ne $Name)) &&
	   defined($self->{Player}{$Client}{ip}))
	   
	{
	    $self->ProcessLogin($Client);
	}

    }
    else
    {
	$self->DebugLog("Unrecognized ClientUserinfoChanged: \<$Args\>");
    }
}

sub ClientDisconnect
{
    my $self = shift;
    my $Timestamp = shift;
    my $Client = shift;
    
    if(defined($self->{Player}{$Client}))
    {
	$self->Log("Client $self->{Player}{$Client}{name} ($Client)",
		   "disconnected");

	#Is the config option set to ban people for some amount of time
	#when they disconnect?

	if($self->{Config}{server}{disconnect_ban} &&
	   !$self->{Player}{$Client}{kicked})
	{
	    $self->Ban($Client,
		       $self->{Config}{server}{disconnect_ban},
		       "disconnect");
	}
	
	#First of all, let's go remove anyone's TKs on this person now,
	#so it doesn't mess up vigilante/revenge stuff when someone
	#comes back in
	foreach my $TmpClient (keys(%{$self->{Player}}))
	{
	    delete($self->{Player}{$TmpClient}{tk_victim_ids}{$Client});
	}
	delete($self->{Player}{$Client});
    }
    else
    {
	#Must've come in in the middle of something.  Well, if he's
	#disconnected, I guess we don't have to worry about him
	#anymore...
#	    $self->DebugLog("UNKNOWN CLIENT Client JUST DISCONNECTED!");
    }
}

sub ClientBegin
{
    my $self = shift;
    my $Timestamp = shift;
    my $Client = shift;

    if(defined($self->{Player}{$Client}))
    {
	$self->{Player}{$Client}{max_possible_grenades} = 
	    $self->ClassGrenadeLimits($self->{Player}{$Client}{class});
    }
}

sub ClientConnect
{
    my $self = shift;
    my $Timestamp = shift;
    my $Client = shift;

    $self->DebugLog("ClientConnect \<$Client\>");

    if(defined($self->{Player}{$Client}))
    {
#	    $self->DebugLog("Uh...client $Client just connected,",
#			    "but I already know of a $Client:",
#			    "$self->{Player}{$Client}{name}");
	delete($self->{Player}{$Client});
    }

    $self->CreateOrUpdateClientInfo($Timestamp, $Client);
}

sub HandleCommand
{
    my $self = shift;
    my $admin = shift;
    my $command = shift;

    ## check for admin functions.  You get to do these if you are an admin (see conf file).  
    ## quote arguments with "
    ## These are:
    ## kick <nick> [<nick> <nick> ...]
    ## kickclient <client id>

    ## WARNING: I don't know of a way to determine which Client said something from the logs (nicks can collide).  
    ##          I choose the first $Client with the correct nick that is an {admin}.  I suggest utilizing the 
    ##          NickServ functionality in conjunction with is_admin.
    
    ## remove leading spaces:
    $admin = StripLeadingAndTrailingWhiteSpace($admin);
    $command = StripLeadingAndTrailingWhiteSpace($command);

    my @command = &shellwords($command);  ## splits up the command into tokens, honoring quotes.

    ## find the requester's client
    my $Client = undef;
    foreach my $tmp_client (keys (%{$self->{Player}})) 
    {
	if ((defined($self->{Player}{$tmp_client}) &&
	     defined($self->{Player}{$tmp_client}{name})) &&
	    (($self->{Player}{$tmp_client}{name} eq $admin) &&
	     $self->{Player}{$tmp_client}{admin}))
	{
	    $Client = $tmp_client;
	    last;
	}
    }

    ## by the time we get here, $Client is the client id of the admin that is performing the function
    if (defined $Client && defined $command[0])
    {
	my $command_string = lc $command[0];
	if ($command_string eq 'kick') 
	{
	    ## lets kick everyone they told us to.
	    for (my $i=1;$i<=$#command;$i++)
	    {
		my @clients_to_kick = ();
		my $lc_search_string = undef;
		my $use_regexp = 0;
		if ($self->{Config}{commands}{regexp_matching} && $command[$i] =~ /^\/(.+)\/$/) 
		{
		    $use_regexp = $1;
		}
		else
		{
		    $lc_search_string = lc $command[$i];
		}
		foreach my $Client (keys(%{$self->{Player}}))
		{
		    if ($use_regexp)
		    {
			## TODO: implement regexp pattern matching
		    }
		    else
		    {
			my $lc_client_name = lc $self->{Player}{$Client}{name};
			if (-1 != index $lc_client_name, $lc_search_string)
			{
			    push @clients_to_kick, $Client;
			} 
		    }
		}
		if ($#clients_to_kick == 0 ) 
		{
		    ## only found one match, kick them.
		    $self->Kick($clients_to_kick[0], 
				"Admin kick by $admin",
				"kicked by admin");
		}
		else
		{
		    ## found more than one, or 0
		    next if $#clients_to_kick < 0;
		    $self->BroadcastMessage('Admin: use kickclient <id> to ruin someone\'s day');

		    foreach my $Client (@clients_to_kick)
		    {
			$self->BroadcastMessage('id: '.$Client,
						$self->{Player}{$Client}{name} || '(unknown name)',
						$self->{Player}{$Client}{team} || '(unknown team)',
						$self->{Player}{$Client}{class} || '(unknown class)',
						'score = '.$self->{Player}{$Client}{score});
		    }
		}
	    }
	} 
	elsif ($command_string eq 'kickclient') 
	{
	    $self->Kick($command[1], 
			"Admin clientkick by $admin",
			"kicked by admin");
	}
	elsif ($command_string eq 'kickall')
	{
	    ## TODO: implement kickall.  Same as kick, just kicks all matching clients
	}
	elsif ($command_string eq 'ban')
	{
	    ## TODO: implement the ban system
	}
	elsif ($command_string eq 'unban')
	{
	    ## TODO: implement the unban system
	}
	elsif($command_string eq 'testadmin' ||
	      $command_string eq 'admintest')
	{
	    $self->Log("Admin test call by $admin");
	}
	else
	{
	    ## command didn't match anything.  Foo.  Write out some debug stuff.
	}
    }
    
} 

sub Say
{
    my $self = shift;
    my $Timestamp = shift;
    my $Args = shift;

    my ($User, $Said) = $self->SplitSay($Args);

    $self->Log("Say $User $Said");
    $self->HandleCommand($User, $Said);
}

sub SayTeam
{
    my $self = shift;
    my $Timestamp = shift;
    my $Args = shift;

    my ($User, $Said) = $self->SplitSay($Args);

    $self->Log("SayTeam $User $Said");
    $self->HandleCommand($User, $Said);
}

sub SplitSay
{
    my $self = shift;
    my $Say = shift;

    ## need the space.  Otherwise, given spifman as a nick, you could change 
    ## your nick to spifman:kick, then just say someone's name and 
    ## they'll be kicked.  (when spifman is online, and is an admin)
    if($Say =~ /(.+?)\: (.+)/)
    {
	my $Sayer = $1;
	my $Said = $2;
	
	$Sayer = StripNameControlCodes($Sayer);
	$Sayer = StripLeadingAndTrailingWhiteSpace($Sayer);
	$Said = StripLeadingAndTrailingWhiteSpace($Said);
	
	return($Sayer, $Said);
    }
    else
    {
	$self->DebugLog("ERR!  Unrecognized SAY command \<$Say\>");
	return(undef, undef);
    }
}

sub StripNameControlCodes
{
    my $Name = shift;

    $Name =~ s/\^.//g;

    return($Name);
}

sub Exit
{
    my $self = shift;
    my $Timestamp = shift;
    my $Args = shift;

    #Exit is only called at the end of a real round, not the end
    #of a ghost round.  So, let's note that the next round is a 
    #ghost round...
    $self->DebugLog("Exit called");
    $self->{State}{NextIsGhostRound} = 1;
    $self->{State}{IsGhostRound} = 0;
    
    my $Winner;
    if($Args =~ /Wolf EndRound/)
    {
	$Winner = "Allies";
    }
    else
    {
	$Winner = "Axis";
    }
    $self->Log("Round End:  $Winner win");
}

sub Item
{
    my $self = shift;
    my $Timestamp = shift;
    my $Args = shift;

    if(my($Recipient, $Item) = ($Args =~ /^(\d+) (\S+)/))
    {
	if($Item eq "weapon_magicammo")
	{
	    if(defined($self->{Player}{$Recipient}))
	    {
		$self->{Player}{$Recipient}{max_possible_grenades}++;
	    }
	}
    }
}

sub Kill
{
    my $self = shift;
    my $Timestamp = shift;
    my $Args = shift;

    #Ignore anything that happens in a ghost round...
    return(0) if($self->{State}{IsGhostRound});
    
    if(my ($Killer, $Victim, $Unk, $KillerName, $VictimName, $MethodKey) =
       ($Args =~ /(\d+) (\d+) (\d+)\: (.*) killed (.*) by (.*)$/))
    {
	my $Method = TranslateWeapon($MethodKey);
	$KillerName =~ s/\^\d//g if(defined($KillerName));
	$VictimName =~ s/\^\d//g if(defined($VictimName));

	if(defined($self->{Player}{$Victim}))
	{
	    $self->{Player}{$Victim}{deaths}++;
	    $self->{Player}{$Victim}{last_death_timestamp} = $Timestamp;
	    $self->{Player}{$Victim}{grenades_this_life} = 0;
	    $self->{Player}{$Victim}{"max_possible_grenades"} = 
		$self->ClassGrenadeLimits($self->{Player}{$Victim}{class});
	    
	    #Ignore \<world\>:
	    if($Killer == 1022 &&
	       $KillerName eq "<world>")
	    {
		$self->{Player}{$Victim}{self_kills}++;
		$self->LogKill("World", $Killer, $Victim, $Method);
		return;
	    }
	    
	    #Ok, let's find the killer:
	    if(defined($self->{Player}{$Killer}))
	    {
		#We don't want to go too hard on self-kills...
		if($Killer == $Victim)
		{
		    $self->{Player}{$Killer}{"self_kills"}++;
		    $self->LogKill("Self", $Killer, $Victim, $Method);
		}
		elsif(defined($self->{Player}{$Victim}{"team"}) &&
		      defined($self->{Player}{$Killer}{"team"}))
		{
		    #We know what team they were on, now, was it legit?
		    if($self->{Player}{$Victim}{"team"} ne
		       $self->{Player}{$Killer}{"team"})
		    {
			#Not a TK!  Let's note it for posterity...
			$self->
			{Player}{$Killer}{consecutive_tk_victims} =
			    0;
			$self->
			{Player}{$Killer}{consecutive_ok_victims}++;
			$self->
			{Player}{$Killer}{ok_victims}++;
			$self->
			{Player}{$Killer}{last_ok} = $Timestamp;
			$self->LogKill("OK", $Killer, $Victim, $Method);
		    }
		    else
		    {
			#They were on the same team.  This bears thinking
			#about in further detail:
			$self->ProcessTK($Timestamp,
					 $Killer,
					 $KillerName,
					 $Victim,
					 $VictimName,
					 $Method,
					 $MethodKey);
		    }
		}
		else
		{
		    #We don't know what team one of these guys is on.
		    #Pretend we didn't see anything...
		    
		    my $KillerTeam = $self->{Player}{$Killer}{team} ||
			"**UNKNOWN TEAM**";
		    my $VictimTeam = $self->{Player}{$Victim}{team} ||
			"**UNKNOWN TEAM**";

		    $self->DebugLog("Unknown Team",
				    "Killer = $Killer (" .
				    $KillerTeam .
				    "), Victim = $Victim (" .
				    $VictimTeam .
				    ")");
		}
	    }
	    else
	    {
		$self->DebugLog("UNKNOWN KILLER $Killer ($KillerName)");
	    }
	}
	else
	{
	    $self->DebugLog("UNKNOWN VICTIM $Victim ($VictimName)");
	}

	#Grenade auditing, if it's on...
	if($self->{Config}{server}{kick_grenade_cheaters} &&
	   ($MethodKey eq "MOD_GRENADE" ||
	    $MethodKey eq "MOD_GRENADE_SPLASH"))
	{
	    #Ok, do we know the user's class?  If not, we can't really
	    #do anything with this.
	    if(defined($self->{Player}{$Killer}{class}))
	    {
		if(!defined($self->{Player}{$Killer}{last_grenade_timestamp}) ||
		   $self->{Player}{$Killer}{last_grenade_timestamp} != $Timestamp)
		{
		    $self->{Player}{$Killer}{last_grenade_timestamp} = $Timestamp;
		    #Ok, it's a new grenade event.   Is this < 5 seconds since
		    #last spawn?  If so, it's by definition a grenade from his
		    #last life, and shouldn't be counted, here.  We'll
		    #let you off the hook if you cheat by getting one
		    #extra grenade off only just as you die.  :)
		    if(!defined($self->{Player}{$Killer}{last_death_timestamp}) ||
		       ($Timestamp -
			$self->{Player}{$Killer}{last_death_timestamp}) > 4)
		    {
			$self->{Player}{$Killer}{max_possible_grenades}--;
			$self->DebugLog("GC $self->{Player}{$Killer}{name} $self->{Player}{$Killer}{max_possible_grenades}");
			$self->{Player}{$Killer}{grenades_this_life}++;
			if($self->{Player}{$Killer}{max_possible_grenades} < 0)
			{
			    #More grenades than he's supposed to have...
			    $self->Kick($Killer,
					"SUSPECTED GRENADE CHEAT; Threw " .
					$self->{Player}{$Killer}{grenades_this_life} .
					" grenades in one life as " .
					$self->{Player}{$Killer}{class},
					"GRENADE CHEATING");
			    $self->Ban($Killer,
				       $self->{Config}{server}{grenade_cheat_ban_time},
				       "Grenade cheating");
			}
		    }
		}
	    }	    
	}
    }
}

sub IsVigilanteTK
{
    my $self = shift;
    my $Killer = shift;
    my $Victim = shift;
    my $Method = shift;
    my $Timestamp = shift;
    my $IsVigilantism = 0;

    #Is this a weapon you can Vigilante kill with?
    return(0) if($NotVengenceWeapon{$Method});
    
    #Is the killer above reproach, or an admin?
    if($self->{Player}{$Killer}{admin} ||
       !$self->{Player}{$Killer}{tk_victims})
    {
	#Second, has the victim killed the killer lately?  If so, it's
	#a revenge kill, not a vigilante kill.
	if(!defined($self->{Player}{$Victim}{tk_victim_ids}{$Killer}))
	{
	    #Lastly, has the victim TKed lately?
	    if((defined($self->{Player}{$Victim}{last_tk})) &&
	       $Timestamp - $self->{Player}{$Victim}{last_tk} <= 
	       $self->{Config}{anti_tk}{vigilante_timer})
	    {
		$IsVigilantism = 1;
	    }
	}
    }

    return($IsVigilantism);
}

sub IsRevengeTK
{
    my $self = shift;
    my $Killer = shift;
    my $Victim = shift;
    my $Method = shift;
    my $IsRevengeTK = 0;

    #Is this a weapon you can Revenge kill with?
    return(0) if($NotVengenceWeapon{$Method});
    
    #Does the killer owe the victim one (or more)?
    if(defined($self->{Player}{$Victim}{tk_victim_ids}{$Killer}) &&
       $self->{Player}{$Victim}{tk_victim_ids}{$Killer} > 0)
    {
	$IsRevengeTK = 1;
    }

    return($IsRevengeTK);
}

sub GetTKPoints
{
    my $self = shift;
    my $Killer = shift;
    my $Victim = shift;
    my $Method = shift;
    my $Timestamp = shift;
    my $MethodKey = $Method;
    $MethodKey =~ tr/A-Z/a-z/;

    #First of all, base points are simply based on method:
    my $Points = $self->WeaponTKPoints($MethodKey);

    #Now, we start giving bonuses out.
    #Have you killed anybody on the other team?
    if(!$self->{Player}{$Killer}{ok_victims})
    {
	#Nope.  Is it within the high danger period?
	if($Timestamp - $self->{"State"}{RoundStart} <
	   $self->{Config}{anti_tk}{initial_danger_period})
	{
	    $Points *= 2;
	}
    }

    #Next bonus - is this a consecutive kill?  And, do we care?
    if($self->{Player}{$Killer}{consecutive_tk_victims})
    {
	$Points +=
	    ($self->{Player}{$Killer}{consecutive_tk_victims} - 1) *
		$self->{Config}{anti_tk}{consecutive_multiplier_bonus};
    }

    #Wow, that could be a lot of points - sucks to be them...
    return($Points);
}

sub AssessPoints
{
    my $self = shift;
    my $Killer = shift;
    my $Victim = shift;
    my $Points = shift;
    my $Timestamp = shift;
    my $Description = shift;
    
    $self->{Player}{$Killer}{tk_score} += $Points;

    my $LogMsg = ("$self->{Player}{$Killer}{name} (" .
		  "$self->{Player}{$Killer}{client}):" .
		  "$self->{Player}{$Victim}{name} (" .
		  "$self->{Player}{$Victim}{client}):" .
		  "$Description:$Points:".
		  "$self->{Player}{$Killer}{tk_score}");
    $self->{Player}{$Killer}{point_log} .= $LogMsg;

    $self->DebugLog($LogMsg);
}

sub ProcessTK
{
    my $self = shift;
    my $Timestamp = shift;
    my $Killer = shift;
    my $KillerName = shift;
    my $Victim = shift;
    my $VictimName = shift;
    my $Method = shift;
    my $MethodKey = shift;

    if($self->IsVigilanteTK($Killer, 
			    $Victim, $Method, $Timestamp))
    {
	my $VictimBonus = $self->{Config}{anti_tk}{victim_vigilante_bonus};
	my $Type = "Vigilante";

	#A white hat killing a TK on his team
	#Was the white hat an admin?  And do we care, anyway?
	if($self->{Config}{anti_tk}{admin_vigilante_points} &&
	   $self->{Player}{$Killer}{admin})
	{
	    $VictimBonus = $self->{Config}{anti_tk}{admin_vigilante_points};
	    $Type = "Admin Vigilante";
	}
	$self->ProcessVigilanteOrRevengeTK($Type,
					   $Killer,
					   $Victim,
					   $self->{Config}{anti_tk}{killer_vigilante_no_points},
					   $self->{Config}{anti_tk}{killer_vigilante_bonus},
					   $VictimBonus,
					   $Method,
					   $MethodKey,
					   $Timestamp);
	$self->LogKill("Vigilante TK", $Killer, $Victim, $Method);
    }
    elsif($self->IsRevengeTK($Killer,
			     $Victim,
			     $Method,
			     $Timestamp))
    {
	#Can't keep killing the same guy more than he kills you :)
	$self->{Player}{$Victim}{tk_victim_ids}{$Killer}--;

	my $VictimBonus = $self->{Config}{anti_tk}{victim_revenge_bonus};
	my $Type = "Revenge";

	#A white hat killing a TK on his team
	#Was the white hat an admin?  And do we care, anyway?
	if($self->{Config}{anti_tk}{admin_revenge_points} &&
	   $self->{Player}{$Killer}{admin})
	{
	    $VictimBonus = $self->{Config}{anti_tk}{admin_revenge_points};
	    $Type = "Admin Revenge";
	}
	
	$self->ProcessVigilanteOrRevengeTK($Type,
					   $Killer,
					   $Victim,
					   $self->{Config}{anti_tk}{killer_revenge_no_points},
					   $self->{Config}{anti_tk}{killer_revenge_bonus},
					   $VictimBonus,
					   $Method,
					   $MethodKey,
					   $Timestamp);
	$self->LogKill("Revenge TK", $Killer, $Victim, $Method);
    }
    else
    {
	#An honest-to-God TK!

	$self->{Player}{$Killer}{tk_victim_ids}{$Victim}++;
	#Don't count as consecutive someone killing three people at once
	#with a grenade:
	$self->{Player}{$Killer}{consecutive_tk_victims}++ 
	    if(defined($self->{Player}{$Killer}{last_tk}) &&
	       $self->{Player}{$Killer}{last_tk} != $Timestamp);
	$self->{Player}{$Killer}{consecutive_ok_victims} = 0;
	$self->{Player}{$Killer}{tk_victims}++;

	my $Points =  $self->GetTKPoints($Killer,
					 $Victim,
					 $MethodKey,
					 $Timestamp);

	$self->AssessPoints($Killer,
			    $Victim,
			    $Points,
			    $Timestamp,
			    "TKed with $Method");


	$self->LogKill("TK", $Killer, $Victim, $Method);
	$self->{Player}{$Killer}{last_tk} = $Timestamp;
    }
}

sub ProcessVigilanteOrRevengeTK
{
    my $self = shift;
    my $Description = shift;
    my $Killer = shift;
    my $Victim = shift;
    my $KillerNoPoints = shift;
    my $KillerBonus = shift;
    my $VictimBonus = shift;
    my $Method = shift;
    my $MethodKey = shift;
    my $Timestamp = shift;

    if(!$KillerNoPoints)
    {
	my $Points;
	
	if($KillerBonus)
	{
	    $Points = $KillerBonus;
	}
	else
	{
	    $self->{Player}{$Killer}{tk_victim_ids}{$Victim}++;
	    #Don't count as consecutive someone killing three people at once
	    #with a grenade:
	    $self->{Player}{$Killer}{consecutive_tk_victims}++ 
		if($self->{Player}{$Killer}{last_tk} != $Timestamp);
	    $self->{Player}{$Killer}{consecutive_ok_victims} = 0;
	    $self->{Player}{$Killer}{tk_victims}++;

	    $Points = $self->GetTKPoints($Killer,
					 $Victim,
					 $MethodKey,
					 $Timestamp);

	    $self->{Player}{$Killer}{last_tk} = $Timestamp;
	}
	$self->AssessPoints($Killer, 
			    $Victim, 
			    $Points, 
			    $Timestamp,
			    "$Description killed with $Method");
    }

    #Now, does the victim get anything special?
    if($VictimBonus)
    {
	$self->AssessPoints($Victim, 
			    $Killer, 
			    $VictimBonus,
			    $Timestamp,
			    "$Description victim bonus");

    }
}

sub StripLeadingAndTrailingWhiteSpace
{
    shift if(ref($_[0])); #Ignore OO crap


    if($#_ > 0)
    {
	my @Strings = @_;

	for(my $x = 0; $x <= $#Strings; ++$x)
	{
	    $Strings[$x] = StripLeadingAndTrailingWhiteSpace($Strings[$x]);
	}

	return(@Strings);
    }
    elsif($#_ == 0 &&
	  defined($_[0]))
    {
	if($_[0] =~ /\S/)
	{
	    $_[0] =~ s/^\s*(\S.*)$/$1/;
	    $_[0] =~ s/^(.*\S)\s*$/$1/;
	}
	else
	{
	    $_[0] = "";
	}
	return($_[0]);
    }
}

sub IsStatPlayer
{
    my $self = shift;
    my @Fields = @_;
    my $IsPlayer = 0;

    if($#Fields == 7)
    {
	if($Fields[0] =~ /^\d+$/ &&
	   $Fields[1] =~ /^([\d\-\+]+)$/ &&
	   $Fields[2] =~ /^\d+$/ &&
	   $Fields[4] =~ /^\d+$/ &&
	   $Fields[5] =~ /^(\d+)\.(\d+)\.(\d+)\.(\d+)\:([\d\-\+]+)$/ &&
	   $Fields[6] =~ /^\d+$/ &&
	   $Fields[7] =~ /^\d+$/)
	{
	    $IsPlayer = 1;
	}
    }

    if(!$IsPlayer)
    {
	if(defined($Fields[0]) &&
	   ($Fields[0] ne 'num' &&
	    $Fields[1] ne 'score' &&
	    $Fields[2] ne 'ping') &&
	   ($Fields[0] ne '---' &&
	    $Fields[1] ne '-----' &&
	    $Fields[2] ne '----'))
	{
	    for(my $x = 0; $x <= $#Fields; ++$x)
	    {
		$Fields[$x] = "\<$Fields[$x]\>";
	    }
	    $self->DebugLog("Rejected as player", @Fields);
	}
    }
    return($IsPlayer);
}

sub CreateOrUpdateClientInfo
{
    my $self = shift;
    my $Timestamp = shift;
    my $ClientID = shift;
    my $Score = shift || 0;
    my $Ping = shift || undef;
    my $Name = shift || undef;
    my $LastMSG = shift || undef;
    my $IP = shift || undef;
    my $QPort = shift || undef;
    my $Rate = shift || undef;
    my $NeedsLogin = 1;
    my $Port;
    my $RawName = $Name;

    if(defined($Name))
    {
	$Name = StripNameControlCodes($Name);
	$Name = StripLeadingAndTrailingWhiteSpace($Name);
    }

    if(defined($IP))
    {
	$IP =~ /^(\d+\.\d+\.\d+\.\d+)\:(.*)$/;
	$IP = $1;
	$Port = $2;
    }

    if(!defined($self->{Player}{$ClientID}))
    {
	$self->DebugLog("Defining new player $ClientID");
	$self->{Player}{$ClientID} = {"client" => $ClientID,
				      "score" => $Score,
				      "ping" => $Ping,
				      "name" => $Name || undef,
				      "raw_name" => $RawName || undef,
				      "team" => undef,
				      "class" => undef,
				      "ip" => $IP,
				      "port" => $Port,
				      "qport" => $QPort,
				      "last_msg" => $LastMSG,
				      "rate" => $Rate
				      };
	$self->ResetClientInfo($ClientID, $Timestamp);
    }
    else
    {
	if(defined($self->{Player}{$ClientID}{name}) &&
	   defined($Name) &&
	   $self->{Player}{$ClientID}{name} eq $Name &&
	   defined($self->{Player}{$ClientID}{ip}))
	{
	    $NeedsLogin = 0;
	}
	$self->{Player}{$ClientID}{client} = $ClientID;
	$self->{Player}{$ClientID}{score} = $Score;
	$self->{Player}{$ClientID}{ping} = $Ping;
	$self->{Player}{$ClientID}{name} = $Name;
	$self->{Player}{$ClientID}{raw_name} = $RawName;
	$self->{Player}{$ClientID}{last_msg} = $LastMSG;
	$self->{Player}{$ClientID}{ip} = $IP;
	$self->{Player}{$ClientID}{port} = $Port;
	$self->{Player}{$ClientID}{QPort} = $QPort;
	$self->{Player}{$ClientID}{rate} = $Rate;
    }

    if(!defined($self->{Player}{$ClientID}{logged_in}))
    {
	$NeedsLogin = 1;
    }

    return($NeedsLogin);
}

sub TranslateTeam
{
    my $Raw = shift;

    if(defined($TranslateTeam{$Raw}))
    {
	return($TranslateTeam{$Raw});
    }
    else
    {
	return("Unknown:  $Raw");
    }
}

sub TranslateWeapon
{
    my $Raw = shift;

    if(defined($TranslateWeapon{$Raw}))
    {
	return($TranslateWeapon{$Raw});
    }
    else
    {
	return("Unknown:  $Raw");
    }
}

sub TranslateClass
{
    my $Raw = shift;

    if(defined($TranslateClass{$Raw}))
    {
	return($TranslateClass{$Raw});
    }
    else
    {
	return("Unknown:  $Raw");
    }
}

sub WeaponTKPoints
{
    my $self = shift;
    my $MethodKey = shift;
    my $RawKey = $MethodKey;

    $MethodKey =~ s/^mod_//i;
    $MethodKey =~ tr[A-Z] [a-z];

    if(defined($self->{Config}{weapon_tk_points}{$MethodKey}))
    {
	$self->DebugLog("Returning",
			$self->{Config}{weapon_tk_points}{$MethodKey},
			"for $MethodKey TK");
	return($self->{Config}{weapon_tk_points}{$MethodKey});
    }

    $self->DebugLog("ERR:  Unknown TK points for \<$RawKey\>\n");
    return(20);
}

sub ProcessLogin
{
    my $self = shift;
    my $Client = shift;

    if(defined($self->{Player}{$Client}) &&
       !defined($self->{Player}{$Client}{logged_in}))
    {
	$self->Log("User connected:  ",
		   $self->{Player}{$Client}{name} || "",
		   "($Client)",
		   $self->{Player}{$Client}{ip});
    }

    $self->{Player}{$Client}{logged_in} = "0";

    #Kick empty names
    if((!defined($self->{Player}{$Client}{name})) ||
       $self->{Player}{$Client}{name} =~ /^\s*$/)
    {
#	$self->DebugLog("Kicking client $Client for an empty name");
	$self->{Player}{$Client}{illegal_name} = "Empty Name";
	#Keep carping on STDERR to a minimum
	$self->{Player}{$Client}{name} = "";
	return;
    }

    #Try to log the guy in, first...
    if(defined($self->{Player}{$Client}{ip}) &&
       defined($self->{Config}{user}{$self->{Player}{$Client}{name}}))
    {
	#Ok, it's a user name we know of.  Are we trying to protect it?
	if($self->{Config}{user}{$self->{Player}{$Client}{name}}{protect_nick})
	{
	    $self->{Player}{$Client}{protect_nick} = 1;
	    $self->{Player}{$Client}{logged_in} = "failed";
	    if(defined($self->{Config}{user}{$self->{Player}{$Client}{name}}{ips}))
	    {
		my @IPs = @{$self->{Config}{user}{$self->{Player}{$Client}{name}}{ips}};
		my $PlayerIP = $self->{Player}{$Client}{ip};
		
		if(defined($PlayerIP))
		{
		    foreach my $IP (@IPs)
		    {
			if(defined($IP) &&
			   ($IP eq $PlayerIP))
			{
			    $self->{Player}{$Client}{logged_in} = "passed";
			    $self->{Player}{$Client}{ignore_offenses} = 
				$self->{Config}{user}{$self->{Player}{$Client}{name}}{ignore_offenses};
			    $self->{Player}{$Client}{admin} = 
				$self->{Config}{user}{$self->{Player}{$Client}{name}}{admin};
			}
		    }
		    if($self->{Player}{$Client}{logged_in} eq "failed")
		    {
			$self->DebugLog("$Client login failed");
		    }
		}
	    }
	}
    }

    #Next question - is it an IP we're banning from?
    if(defined($self->{Player}{$Client}{ip}) &&
       defined($self->{Config}{ip}{$self->{Player}{$Client}{ip}}))
    {
	#A little sanity in the references:
	my $ClientIP = $self->{Player}{$Client}{ip};
	#Ok, it is an IP we know about.  Is it banned?
	if($self->{Config}{ip}{$ClientIP}{banned})
	{
	    $self->DebugLog("IP $ClientIP is banned:  \<" .
			    "$self->{Config}{ip}{$ClientIP}{banned}\>:",
			    $self->{Config}{ip}{$ClientIP}{banned_time});
	    #Yes.  Is there a timelimit on it?
	    if(defined($self->{Config}{ip}{$ClientIP}{banned_time}) &&
	       $self->{Config}{ip}{$ClientIP}{banned_time} > 0)
	    {
		#Yes, there is.  Is it still active?
		if($self->{Config}{ip}{$ClientIP}{banned_time} 
		   >= time())
		{
		    $self->{Player}{$Client}{banned} = 1;
		    $self->{Player}{$Client}{banned_time} = 
			$self->{Config}{ip}{$ClientIP}{banned_time};
		    $self->DebugLog("Setting temp ban for",
				    $ClientIP,
				    $self->{Config}{ip}{$ClientIP}{banned_time},
				    ">= " . time());
		}
		else
		{
		    #No, it's not, let's ignore it, and remove it:
		    $self->DebugLog("Temp ban removed for",
				    $ClientIP,
				    $self->{Config}{ip}{$ClientIP}{banned_time},
				    "<= " . time());

		    $self->{Player}{$Client}{banned} = 0;
		    $self->{Player}{$Client}{banned_time} = undef;

		    delete($self->{Config}{ip}{$ClientIP}{banned});
		    delete($self->{Config}{ip}{$ClientIP}{banned_time});
		    delete($self->{Config}{ip}{$ClientIP});
		}
	    }
	    else
	    {
		#No timelimit = can't log on, ever.
		$self->{Player}{$Client}{banned} = 1;
		$self->{Player}{$Client}{banned_time} = undef;
		$self->DebugLog("Setting perma ban for",
				$ClientIP);
	    }
	}
    }

    if($self->{Config}{server}{enforce_names} &&
       !$self->{Player}{$Client}{ignore_offenses})

    {
	#While we're here, let's look for illegal names, too
	foreach my $BadName (@{$self->{Config}{server}{"illegal_names"}})
	{
	    if(defined($self->{Player}{$Client}{name}) &&
	       $self->{Player}{$Client}{"name"} =~ /$BadName/i)
	    {
		#One other possibility.  If we have no IP, and that
		#is the name of a known player, let's wait until we
		#get an IP
		if(defined($self->{Player}{$Client}{ip}) ||
		   ((!defined($self->{Player}{$Client}{ip})) &&
		    (!defined($self->{Config}{user}{$self->{Player}{$Client}{name}}))))
		{
		    $self->{Player}{$Client}{illegal_name} = 
			"Name matched keyword \<$BadName\>";
		}
	    }
	}

	if((!$self->{Player}{$Client}{illegal_name}) &&
	   $self->{Config}{server}{kick_names_with_leading_spaces} &&
	   $self->{Player}{$Client}{raw_name} =~ /^\s/)
	{
	    $self->{Player}{$Client}{illegal_name} =
		"Name has one or more leading spaces";
	}
    }
}

sub Kick
{
    my $self = shift;
    my $Client = shift;
    my $LogReason = shift;
    my $BroadcastReason = shift || undef;

    unless($self->{Player}{$Client}{ignore_offenses})
    {
	$self->Log("KICK", 
		   $self->{Player}{$Client}{name} || "Unknown",
		   "($Client)".
		   ": $LogReason");
	
	$self->{Player}{$Client}{kicked} = 1;
	if($self->{Config}{server}{kick_users} &&
	   !$self->{Config}{'#args'}{test_mode})
	{
	    $self->RCONCmd(0, "clientkick $Client");
	    $self->BroadcastMessage("$self->{Player}{$Client}{name}" .
				    " kicked:  $BroadcastReason") 
		if(defined($BroadcastReason));
	}
    }
    else
    {
	$self->Log("Would've kicked $self->{Player}{$Client}{name}",
		   "($Client)",
		   "for $LogReason; but is ignore_offenses");
    }
}

sub Ban
{
    my $self = shift;
    my $Client = shift;
    my $Seconds = shift;
    my $Reason = shift;

    unless($self->{Player}{$Client}{ignore_offenses})
    {
	if(defined($self->{Player}{$Client}{ip}))
	{
	    $self->Log("BAN $self->{Player}{$Client}{name}",
		       "($Client)",
		       $self->{Player}{$Client}{ip},
		       "for $Seconds seconds ($Reason)");
	    
	    $self->{Config}{ip}{$self->{Player}{$Client}{ip}}{banned} = 1;
	    if($Seconds > 0)
	    {
		$self->{Config}{ip}{$self->{Player}{$Client}{ip}}{banned_time} = 
		    time() + $Seconds;
	    }
	    else
	    {
		$self->{Config}{ip}{$self->{Player}{$Client}{ip}}{banned_time} = 0;
	    }
	}
	else
	{
	    $self->Log("BAN $self->{Player}{$Client}{name}",
		       "($Client)",
		       "**UNKNOWN IP SO NOT ACTUALLY BANNED**",
		       "for $Seconds seconds ($Reason)");
	}
    }
    else
    {
	$self->Log("Would've banned $self->{Player}{$Client}{name}",
		   "($Client)",
		   $self->{Player}{$Client}{ip},
		   "for $Seconds seconds ($Reason); but is ignore_offenses");
    }
}

sub LogKill
{
    my $self = shift;
    my $Type = shift;
    my $Killer = shift;
    my $Victim = shift;
    my $Method = shift;

    if($Killer == 1022)
    {
	#World kill
	$self->Log("$Type Kill \<World\> ",
		   "(1022)",
		   "killed $self->{Player}{$Victim}{name}",
		   "($Victim:$self->{Player}{$Victim}{tk_score})",
		   "with $Method");

    }
    else
    {
	$self->Log("$Type Kill $self->{Player}{$Killer}{name}",
		   "($Killer:$self->{Player}{$Killer}{tk_score})",
		   "killed $self->{Player}{$Victim}{name}",
		   "($Victim:$self->{Player}{$Victim}{tk_score})",
		   "with $Method");
    }
}

sub LogUserInfoChange
{
    my $self = shift;
    my $Client = shift;
    my $Name = shift;
    my $Team = shift;
    my $Class = shift;

    #Let's not log class-only changes, or initial changes before we get
    #the connection
    if((defined($self->{Player}{$Client}{name}) &&
	defined($self->{Player}{$Client}{team})) &&
       ($self->{Player}{$Client}{name} ne $Name ||
	$self->{Player}{$Client}{team} ne $Team))
    {
	my $OldName = $self->{Player}{$Client}{name} || "Unknown";
	my $OldTeam = $self->{Player}{$Client}{team} || "Unknown";

	#If this is just a team change from unknown, ignore it
	$self->Log("InfoChange \<$OldName\>/$Class ($Client) on " .
		   "$OldTeam changed to",
		   "\<$Name\>/$Class ($Client) on $Team");
    }
}

sub ResetClientInfo
{
    my $self = shift;
    my $Client = shift;
    my $Timestamp = shift;

    $self->{Player}{$Client}{"self_kills"} = 0;
    $self->{Player}{$Client}{"deaths"} = 0;
    $self->{Player}{$Client}{"tk_score"} = 0;
    $self->{Player}{$Client}{"point_log"} = "";
    $self->{Player}{$Client}{"tk_victim_ids"} = {};
    $self->{Player}{$Client}{"consecutive_tk_victims"} = 0;
    $self->{Player}{$Client}{"consecutive_ok_victims"} = 0;
    $self->{Player}{$Client}{"tk_victims"} = 0;
    $self->{Player}{$Client}{"ok_victims"} = 0;
    $self->{Player}{$Client}{"kicked"} = 0;
    $self->{Player}{$Client}{"banned"} = 0;
    $self->{Player}{$Client}{"banned_time"} = undef;
    $self->{Player}{$Client}{"logged_in"} = undef;
    $self->{Player}{$Client}{"protect_nick"} = 0;
    $self->{Player}{$Client}{"ignore_offenses"} = 0;
    $self->{Player}{$Client}{"admin"} = 0;
    $self->{Player}{$Client}{"illegal_name"} = 0;
    $self->{Player}{$Client}{"first_seen"} = $Timestamp;
    $self->{Player}{$Client}{"last_grenade_timestamp"} = undef;
    $self->{Player}{$Client}{"grenades_this_life"} = 0;
    $self->{Player}{$Client}{"max_possible_grenades"} = 
	$self->ClassGrenadeLimits($self->{Player}{$Client}{class});
}

sub ResetFH
{
    my $FH = shift;

    seek($FH, 0, 1);  
}

sub SeekToEnd
{
    my $FH = shift;

    seek($FH, 0, 2);
}

sub GetCVars
{
    my $self = shift;
    my $Vars = undef;

    my @Response = $self->RCONCmd(1, "cvarlist");

    foreach my $Response (@Response)
    {
	if($Response =~ /\s*(\S+) \"(.*)\"/)
	{
	    $Vars->{$1} = $2;
	}
    }
    
    return($Vars);
}

sub RCONCmd
{
    my $self = shift;
    my $ExpectResponse = shift;

    return($self->_RawRCONCmd($self->{State}{ServerSocket}, 
			      $ExpectResponse, @_));
}

sub _RawRCONCmd
{
    my $self = shift;
    my $Socket = shift;
    my $ExpectResponse = shift;
    my $Cmd = join(" ", @_);
    my $CriticalProblem = 0;
    my @Response;
    my $TryAgain = 0;
    my $Retry = $self->{Config}{server}{retry};

    return(undef) if(!$self->Continue() ||
		     $self->{Config}{"#args"}{test_mode});
    
    #Let's dump any existing data that's pending, if they care about the
    #response:
    if($ExpectResponse)
    {
	my @Junk = $self->GetServerResponse(0, $Socket);
    }
    
    do
    {
	$TryAgain = 0;

	my $RCONString = $Magic  . "rcon " .
	    "$self->{Config}{server}{rcon} $Cmd"; 
#	$self->DebugLog($RCONString);
	print {$Socket} $RCONString;
	
	if($ExpectResponse)
	{
	    @Response = $self->GetServerResponse(1, $Socket);

	    #Now's where we find out of the server has died.  Was there
	    #a timeout?
	    if($self->{State}{ConnectionTimedOut})
	    {
		#Yup, it did.  That's probably bad.  Can we do anything about
		#it?
		if($Retry)
		{
		    $Retry--;
		    $self->Log("Connection timed out, retrying; $Retry left\n");
		    $self->{State}{ConnectionTimedOut} = 0;
		    $TryAgain = 1;
		}
		else
		{
		    $CriticalProblem = 1;
		    
		    if($self->{Config}{server}{kill_server})
		    {
			#First of all, is there a proc associated?
			my $PID = 
			    $self->FindSocketOwner($self->{Config}{server}{oob_port});
			
			if(defined($PID))
			{
			    $self->DebugLog("Server PID seems to be $PID");
			    #Ok, there is still a proc associated.  I guess now we
			    #try to kill it...
			    if($self->KillProc($PID))
			    {
				#Looks like we were successful.  Let's sleep for
				#a bit to let things get together...
				sleep($self->{Config}{server}{restart_sleep});
				
				#Now, we'll cross our fingers and try again...
				$TryAgain = 1;
				$CriticalProblem = 0;
				$self->{State}{ConnectionTimedOut} = 0;
				$self->ServerDisconnect();
				$self->ServerConnect();
				$Socket = $self->{State}{ServerSocket};
			    }
			}
			else
			{
			    $self->DebugLog("Would've killed server, but can't find it.");
			}
		    }
		    elsif($self->{Config}{server}{reconnect_on_failure})
		    {
			$self->Log("Sleeping " .
				   "$self->{Config}{server}{reconnect_sleep}".
				   "; will try to reconnect...");
			sleep($self->{Config}{server}{reconnect_sleep});
			$TryAgain = 1;
			$CriticalProblem = 0;
			$self->{State}{ConnectionTimedOut} = 0;
			$self->ServerDisconnect();
			$self->ServerConnect();
			$Socket = $self->{State}{ServerSocket};
			$Retry = $self->{Config}{server}{retry};
		    }
		    else
		    {
			$self->DebugLog("Not trying to kill server; !kill_server");
		    }
		}

		if($CriticalProblem)
		{
		    #We weren't able to fix it.  Probably because there doesn't
		    #seem to be a server running, anymore.  No server, no
		    #reason for us to keep running...
		    $self->DebugLog("Unfixable problem with server, giving up");
		    $self->Continue(0);
		}
	    }
	}
    }while($TryAgain);

    #Temporary workaround for 0.9.2, where it would ignore commands issued
    #right after a "status":
    #Perhaps not so temporary; still needed in 1.0
    sleep(1);
    
    return(@Response);
}

sub SetWABVersion
{
    my $self = shift;
    
    $self->RCONCmd(0, "sets wab_version $VERSION");
}

sub AnalyzeConfiguration
{
    my $self = shift;

    return;

    if($self->{Config}{"#args"}{debug} &&
       defined($self->{Config}{server}{debug_logfile}))
    {
	$self->DebugLog("New configuration $VERSION:");

	my $OUF = gensym();
	if(open($OUF, ">>$self->{Config}{server}{debug_logfile}"))
	{
	    _DumpThings($OUF, 0, 0, $self->{Config});
	    _DumpThings($OUF, 0, 0, $self->{State});
	    close($OUF);
	}
	
	#Now, let's do some tests...

	my $TmpSocket;
	if(defined($TmpSocket = 
		 IO::Socket::INET->new("PeerAddr" => 
				       $self->{"Config"}{"server"}{"ip"},
				       "PeerPort" =>
				       $self->{"Config"}
				       {"server"}{"oob_port"},
				       "Proto" => "udp",
				       "Timeout" => 
				       $self->{Config}{server}{timeout})))
	{
	    $self->DebugLog("Successfully connected to " .
			    "$self->{Config}{server}{ip}:" .
			    $self->{Config}{server}{oob_port});
	    $TmpSocket->timeout($self->{Config}{server}{timeout});
	    
	    #Let's try an rcon thingy
	    my @Response = $self->_RawRCONCmd($TmpSocket, 1, "fs_basepath");
	    
	    if($#Response >= 0)
	    {
		for(my $x = 0; $x <= $#Response; ++$x)
		{
		    $self->DebugLog("fs_basepath $x \<$Response[$x]\>");
		}
	    }
	    else
	    {
		$self->DebugLog("Got no lines back from fs_basepath");
	    }

	    close($TmpSocket);
	}
	else
	{
	    $self->DebugLog("Unable to connect to " .
			    "$self->{Config}{server}{ip}:" .
			    $self->{Config}{server}{oob_port} . 
			    ":  $!");
	}
	
	#Make sure we can read the game logfile
	if(-r $self->{Config}{server}{game_logfile})
	{
	    $self->DebugLog("Can read game logfile",
			    "$self->{Config}{server}{game_logfile}");
	}
	else
	{
	    $self->DebugLog("CANNOT read game logfile",
			    "$self->{Config}{server}{game_logfile}");
	}
    }
}

sub BroadcastMessage
{
    my $self = shift;
    my $Msg = join(' ', @_);
    
    $self->Log("SAY:  $Msg");

    $self->RCONCmd(0, "say $Msg");
}

sub Version
{
    return($VERSION);
}

sub Files
{
    return(%Files);
}

sub FindSocketOwner
{
    my $self = shift;
    my $Port = shift;
    my %Port;
    my %Inode;
    
    my $HexPort = sprintf("%X", $Port);
    
    #Ok, let's try to find the socket in proc...
    
    my $UDP = gensym();
    if(open($UDP, "/proc/net/udp"))
    {
	while(defined($_ = readline($UDP)))
	{
	    chomp;
	    my $Inode;
	    my $TmpPort;

	    my @Fields = split(' ', $_);

	    if($#Fields >= 9)
	    {
		$TmpPort = $Fields[1];
		$Inode = $Fields[9];
		$TmpPort =~ s/^.*\:([ABCDEF0123456789]{4})$/$1/;

		if(defined($Inode) &&
		   defined($TmpPort))
		{
		    if($TmpPort eq $HexPort)
		    {
			$Port{$TmpPort} = $Inode;
		    }
		}
	    }

	}
	close($UDP);
	
	if(keys(%Port))
	{
	    #We found one, let's cache all the inodes out there...
	    %Inode = $self->CacheInodePIDs();
	    foreach my $TmpPort (keys(%Port))
	    {
		$self->DebugLog("$TmpPort seems to be owned by",
				"$Inode{$Port{$TmpPort}}");
	    }
	}
    }
    else
    {
	$self->DebugLog("Can't read /proc/net/udp:  $!");
    }
    
    if(defined($Inode{$Port{$HexPort}}))
    {
	return($Inode{$Port{$HexPort}});
    }
    return(undef);
}

sub CacheInodePIDs
{
    my $self = shift;
    my %Inode;
    
    my $PROC = gensym();
    if(opendir($PROC, "/proc"))
    {
	my $Dir;
	my $PID;
	
	while(defined($Dir = readdir($PROC)))
	{
	    if($Dir =~ /^\d+$/)
	    {
		$PID = $Dir;
		$Dir = "/proc/$Dir/fd";
		
		my $FDH = gensym();
		
		#We don't complain about opendir errors because there are a lot
		#of reasons we can't read a PID dir (permissions, program
		#terminated, etc.
		if(opendir($FDH, $Dir))
		{
		    my $fd;
		    while(defined($fd = readdir($FDH)))
		    {
			if(defined(my $Dest = readlink("$Dir/$fd")))
			{
			    chomp($Dest);
			    
			    if($Dest =~ /^socket\:\[(\d+)\]/)
			    {
				my $Inode = $1;
				$Inode{$Inode} = $PID;
			    }
			}
		    }
		    closedir($FDH);
		}
	    }
	}
	closedir($PROC);
    }
    else
    {
	$self->DebugLog("Unable to read /proc:  $!");
    }
    
    return(%Inode);
}

sub KillProc
{
    my $self = shift;
    my $PID = shift;
    my $Killed = 1;

    $self->DebugLog("Killing PID $PID...");
    if(!$self->{Config}{"#args"}{test_mode})
    {
	$self->DebugLog("Sending $PID TERM signal");
	kill('TERM', $PID);
	sleep(5);
	if($self->ProcRunning($PID))
	{
	    $self->DebugLog("Sending $PID KILL signal");
	    kill('KILL', $PID)
	}

	$Killed = !($self->ProcRunning($PID));

	$self->DebugLog("Killed = $Killed");
    }
    
    return($Killed);
}

sub ProcRunning
{
    my $self = shift;
    my $PID = shift;
    
    $self->DebugLog("/proc/$PID");
    
    if(-d "/proc/$PID")
    {
	return(1);
    }
    return(0);
}

sub DumpState
{
    my $self = shift;

    my $OUF = gensym();
    if(open($OUF, ">>$self->{Config}{server}{debug_logfile}"))
    {
	_DumpThings($OUF, 0, 0, $self->{Config});
	_DumpThings($OUF, 0, 0, $self->{State});
	_DumpThings($OUF, 0, 0, $self->{Player});
	
	close($OUF);
    }
}

sub ClassGrenadeLimits
{
    my $self = shift;
    my $Class = shift || undef;

    if(defined($Class))
    {
	if($Class eq "Soldier")
	{
	    return($self->{Config}{server}{soldier_grenades});
	}
	elsif($Class eq "Medic")
	{
	    return($self->{Config}{server}{medic_grenades});
	}
	elsif($Class eq "Engineer")
	{
	    return($self->{Config}{server}{engineer_grenades});
	}
	elsif($Class eq "Lieutenant")
	{
	    return($self->{Config}{server}{lt_grenades});
	}
    
	$self->DebugLog("Unknown Class \<$Class\>:  Huh?");
    }

    #If, for some reason, we don't know the class, we'll assume their an
    #engineer:
    return($self->{Config}{server}{engineer_grenades});
}
1;
